/*
 * TVIN signal format table
 *
 * Author: Lin Xu <lin.xu@amlogic.com>
 *         Bobby Yang <bo.yang@amlogic.com>
 *
 * Copyright (C) 2010 Amlogic Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */


#include <linux/module.h>

#include "tvin_global.h"
#include "tvin_format_table.h"

const char * tvin_sig_fmt_str(enum tvin_sig_fmt_e fmt)
{
	switch (fmt)
	{
		case TVIN_SIG_FMT_NULL:
			return "TVIN_SIG_FMT_NULL";
			break;
		case TVIN_SIG_FMT_VGA_512X384P_60HZ_D147:
			return "TVIN_SIG_FMT_VGA_512X384P_60D147";
			break;
		case TVIN_SIG_FMT_VGA_560X384P_60HZ_D147:
			return "TVIN_SIG_FMT_VGA_560X384P_60D147";
			break;
		case TVIN_SIG_FMT_VGA_640X200P_59HZ_D924:
			return "TVIN_SIG_FMT_VGA_640X200P_59D924";
			break;
		case TVIN_SIG_FMT_VGA_640X350P_85HZ_D080:
			return "TVIN_SIG_FMT_VGA_640X200P_59D924";
			break;
		case TVIN_SIG_FMT_VGA_640X400P_59HZ_D940:
			return "TVIN_SIG_FMT_VGA_640X400P_59D940";
			break;
		case TVIN_SIG_FMT_VGA_640X400P_85HZ_D080:
			return "TVIN_SIG_FMT_VGA_640X400P_85D080";
			break;
		case TVIN_SIG_FMT_VGA_640X400P_59HZ_D638:
			return "TVIN_SIG_FMT_VGA_640X400P_59D638";
			break;
		case TVIN_SIG_FMT_VGA_640X400P_56HZ_D416:
			return "TVIN_SIG_FMT_VGA_640X400P_56D416";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_66HZ_D619:
			return "TVIN_SIG_FMT_VGA_640X480P_66D619";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_66HZ_D667: //10
			return "TVIN_SIG_FMT_VGA_640X480P_66D667";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_59HZ_D940:
			return "TVIN_SIG_FMT_VGA_640X480P_59D940";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_640X480P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_72HZ_D809:
			return "TVIN_SIG_FMT_VGA_640X480P_72D809";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_75HZ_D000_A:
			return "TVIN_SIG_FMT_VGA_640X480P_75D000_A";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_85HZ_D008:
			return "TVIN_SIG_FMT_VGA_640X480P_85D008";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_59HZ_D638:
			return "TVIN_SIG_FMT_VGA_640X480P_59D638";
			break;
		case TVIN_SIG_FMT_VGA_640X480P_75HZ_D000_B:
			return "TVIN_SIG_FMT_VGA_640X480P_75D000_B";
			break;
		case TVIN_SIG_FMT_VGA_640X870P_75HZ_D000:
			return "TVIN_SIG_FMT_VGA_640X870P_75D000";
			break;
		case TVIN_SIG_FMT_VGA_720X350P_70HZ_D086:
			return "TVIN_SIG_FMT_VGA_720X350P_70D086";
			break;
		case TVIN_SIG_FMT_VGA_720X400P_85HZ_D039: //20
			return "TVIN_SIG_FMT_VGA_720X400P_85D039";
			break;
		case TVIN_SIG_FMT_VGA_720X400P_70HZ_D086:
			return "TVIN_SIG_FMT_VGA_720X400P_70D086";
			break;
		case TVIN_SIG_FMT_VGA_720X400P_87HZ_D849:
			return "TVIN_SIG_FMT_VGA_720X400P_87D849";
			break;
		case TVIN_SIG_FMT_VGA_720X400P_59HZ_D940:
			return "TVIN_SIG_FMT_VGA_720X400P_59D940";
			break;
		case TVIN_SIG_FMT_VGA_720X480P_59HZ_D940:
			return "TVIN_SIG_FMT_VGA_720X480P_59D940";
			break;
		case TVIN_SIG_FMT_VGA_768X480P_59HZ_D896:
			return "TVIN_SIG_FMT_VGA_768X480P_59D896";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_56HZ_D250:
			return "TVIN_SIG_FMT_VGA_800X600P_56D250";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_800X600P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_60HZ_D000_A:
			return "TVIN_SIG_FMT_VGA_800X600P_60D000_A";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_60HZ_D317:
			return "TVIN_SIG_FMT_VGA_800X600P_60D317";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_72HZ_D188: //30
			return "TVIN_SIG_FMT_VGA_800X600P_72D188";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_75HZ_D000:
			return "TVIN_SIG_FMT_VGA_800X600P_75D000";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_85HZ_D061:
			return "TVIN_SIG_FMT_VGA_800X600P_85D061";
			break;
		case TVIN_SIG_FMT_VGA_832X624P_75HZ_D087:
			return "TVIN_SIG_FMT_VGA_832X624P_75D087";
			break;
		case TVIN_SIG_FMT_VGA_848X480P_84HZ_D751:
			return "TVIN_SIG_FMT_VGA_848X480P_84D751";
			break;
		case TVIN_SIG_FMT_VGA_960X600P_59HZ_D635:
			return "TVIN_SIG_FMT_VGA_960X600P_59D635";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_59HZ_D278:
			return "TVIN_SIG_FMT_VGA_1024X768P_59D278";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1024X768P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000_A:
			return "TVIN_SIG_FMT_VGA_1024X768P_60D000_A";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000_B:
			return "TVIN_SIG_FMT_VGA_1024X768P_60D000_B";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_74HZ_D927:  //40
			return "TVIN_SIG_FMT_VGA_1024X768P_74D927";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D004:
			return "TVIN_SIG_FMT_VGA_1024X768P_60D004";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_70HZ_D069:
			return "TVIN_SIG_FMT_VGA_1024X768P_70D069";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_75HZ_D029:
			return "TVIN_SIG_FMT_VGA_1024X768P_75D029";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_84HZ_D997:
			return "TVIN_SIG_FMT_VGA_1024X768P_84D997";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_74HZ_D925:
			return "TVIN_SIG_FMT_VGA_1024X768P_74D925";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D020:
			return "TVIN_SIG_FMT_VGA_1024X768P_60D020";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_70HZ_D008:
			return "TVIN_SIG_FMT_VGA_1024X768P_70D008";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_75HZ_D782:
			return "TVIN_SIG_FMT_VGA_1024X768P_75D782";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_77HZ_D069:
			return "TVIN_SIG_FMT_VGA_1024X768P_77D069";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_71HZ_D799:  //50
			return "TVIN_SIG_FMT_VGA_1024X768P_71D799";
			break;
		case TVIN_SIG_FMT_VGA_1024X1024P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1024X1024P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1152X864P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1152X864P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1152X864P_70HZ_D012:
			return "TVIN_SIG_FMT_VGA_1152X864P_70D012";
			break;
		case TVIN_SIG_FMT_VGA_1152X864P_75HZ_D000:
			return "TVIN_SIG_FMT_VGA_1152X864P_75D000";
			break;
		case TVIN_SIG_FMT_VGA_1152X864P_84HZ_D999:
			return "TVIN_SIG_FMT_VGA_1152X864P_84D999";
			break;
		case TVIN_SIG_FMT_VGA_1152X870P_75HZ_D062:
			return "TVIN_SIG_FMT_VGA_1152X870P_75D062";
			break;
		case TVIN_SIG_FMT_VGA_1152X900P_65HZ_D950:
			return "TVIN_SIG_FMT_VGA_1152X900P_65D950";
			break;
		case TVIN_SIG_FMT_VGA_1152X900P_66HZ_D004:
			return "TVIN_SIG_FMT_VGA_1152X900P_66D004";
			break;
		case TVIN_SIG_FMT_VGA_1152X900P_76HZ_D047:
			return "TVIN_SIG_FMT_VGA_1152X900P_76D047";
			break;
		case TVIN_SIG_FMT_VGA_1152X900P_76HZ_D149: //60
			return "TVIN_SIG_FMT_VGA_1152X900P_76D149";
			break;
		case TVIN_SIG_FMT_VGA_1280X720P_59HZ_D855:
			return "TVIN_SIG_FMT_VGA_1280X720P_59D855";
			break;
		case TVIN_SIG_FMT_VGA_1280X720P_60HZ_D000_A:
			return "TVIN_SIG_FMT_VGA_1280X720P_60D000_A";
			break;
		case TVIN_SIG_FMT_VGA_1280X720P_60HZ_D000_B:
			return "TVIN_SIG_FMT_VGA_1280X720P_60D000_B";
			break;
		case TVIN_SIG_FMT_VGA_1280X720P_60HZ_D000_C:
			return "TVIN_SIG_FMT_VGA_1280X720P_60D000_C";
			break;
		case TVIN_SIG_FMT_VGA_1280X720P_60HZ_D000_D:
			return "TVIN_SIG_FMT_VGA_1280X720P_60D000_D";
			break;
		case TVIN_SIG_FMT_VGA_1280X768P_59HZ_D870:
			return "TVIN_SIG_FMT_VGA_1280X768P_59D870";
			break;
		case TVIN_SIG_FMT_VGA_1280X768P_59HZ_D995:
			return "TVIN_SIG_FMT_VGA_1280X768P_59D995";
			break;
		case TVIN_SIG_FMT_VGA_1280X768P_60HZ_D100:
			return "TVIN_SIG_FMT_VGA_1280X768P_60D100";
			break;
		case TVIN_SIG_FMT_VGA_1280X768P_85HZ_D000:
			return "TVIN_SIG_FMT_VGA_1280X768P_85HZ_D000";
			break;
		case TVIN_SIG_FMT_VGA_1280X768P_74HZ_D893: //70
			return "TVIN_SIG_FMT_VGA_1280X768P_74D893";
			break;
		case TVIN_SIG_FMT_VGA_1280X768P_84HZ_D837:
			return "TVIN_SIG_FMT_VGA_1280X768P_84D837";
			break;
		case TVIN_SIG_FMT_VGA_1280X800P_59HZ_D810:
			return "TVIN_SIG_FMT_VGA_1280X800P_59D810";
			break;
		case TVIN_SIG_FMT_VGA_1280X800P_59HZ_D810_A:
			return "TVIN_SIG_FMT_VGA_1280X800P_59D810_A";
			break;
		case TVIN_SIG_FMT_VGA_1280X800P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1280X800P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1280X800P_85HZ_D000:
			return "TVIN_SIG_FMT_VGA_1280X800P_85D000";
			break;
		case TVIN_SIG_FMT_VGA_1280X960P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1280X960P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1280X960P_60HZ_D000_A:
			return "TVIN_SIG_FMT_VGA_1280X960P_60D000_A";
			break;
		case TVIN_SIG_FMT_VGA_1280X960P_75HZ_D000:
			return "TVIN_SIG_FMT_VGA_1280X960P_75D000";
			break;
		case TVIN_SIG_FMT_VGA_1280X960P_85HZ_D002:
			return "TVIN_SIG_FMT_VGA_1280X960P_85D002";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_60HZ_D020: //80
			return "TVIN_SIG_FMT_VGA_1280X1024P_60D020";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_60HZ_D020_A:
			return "TVIN_SIG_FMT_VGA_1280X1024P_60D020_A";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_75HZ_D025:
			return "TVIN_SIG_FMT_VGA_1280X1024P_75D025";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_85HZ_D024:
			return "TVIN_SIG_FMT_VGA_1280X1024P_85D024";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_59HZ_D979:
			return "TVIN_SIG_FMT_VGA_1280X1024P_59D979";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_72HZ_D005:
			return "TVIN_SIG_FMT_VGA_1280X1024P_72D005";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_60HZ_D002:
			return "TVIN_SIG_FMT_VGA_1280X1024P_60D002";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_67HZ_D003:
			return "TVIN_SIG_FMT_VGA_1280X1024P_67D003";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_74HZ_D112:
			return "TVIN_SIG_FMT_VGA_1280X1024P_74D112";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_76HZ_D179:
			return "TVIN_SIG_FMT_VGA_1280X1024P_76D179";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_66HZ_D718: //90
			return "TVIN_SIG_FMT_VGA_1280X1024P_66D718";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_66HZ_D677:
			return "TVIN_SIG_FMT_VGA_1280X1024P_66D677";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_76HZ_D107:
			return "TVIN_SIG_FMT_VGA_1280X1024P_76D107";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_59HZ_D996:
			return "TVIN_SIG_FMT_VGA_1280X1024P_59D996";
			break;
		case TVIN_SIG_FMT_VGA_1280X1024P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1280X1024P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1360X768P_59HZ_D799:
			return "TVIN_SIG_FMT_VGA_1360X768P_59D799";
			break;
		case TVIN_SIG_FMT_VGA_1360X768P_60HZ_D015:
			return "TVIN_SIG_FMT_VGA_1360X768P_60D015";
			break;
		case TVIN_SIG_FMT_VGA_1360X768P_60HZ_D015_A:
			return "TVIN_SIG_FMT_VGA_1360X768P_60D015_A";
			break;
		case TVIN_SIG_FMT_VGA_1360X850P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1360X850P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1360X1024P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1360X1024P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1366X768P_59HZ_D790: //100
			return "TVIN_SIG_FMT_VGA_1366X768P_59D790";
			break;
		case TVIN_SIG_FMT_VGA_1366X768P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1366X768P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1400X1050P_59HZ_D978:
			return "TVIN_SIG_FMT_VGA_1400X1050P_59D978";
			break;
		case TVIN_SIG_FMT_VGA_1440X900P_59HZ_D887:
			return "TVIN_SIG_FMT_VGA_1440X900P_59D887";
			break;
		case TVIN_SIG_FMT_VGA_1440X1080P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1440X1080P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1600X900P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1600X900P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1600X1024P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1600X1024P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1600X1200P_59HZ_D869:
			return "TVIN_SIG_FMT_VGA_1600X1200P_59HZ_D869";
			break;
		case TVIN_SIG_FMT_VGA_1600X1200P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1600X1200P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1600X1200P_65HZ_D000:
			return "TVIN_SIG_FMT_VGA_1600X1200P_65D000";
			break;
		case TVIN_SIG_FMT_VGA_1600X1200P_70HZ_D000:
			return "TVIN_SIG_FMT_VGA_1600X1200P_70D000";
			break;
		case TVIN_SIG_FMT_VGA_1680X1050P_59HZ_D954: //110
			return "TVIN_SIG_FMT_VGA_1680X1050P_59D954";
			break;
		case TVIN_SIG_FMT_VGA_1680X1080P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1680X1080P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1920X1080P_49HZ_D929:
			return "TVIN_SIG_FMT_VGA_1920X1080P_49HZ_D929";
			break;
		case TVIN_SIG_FMT_VGA_1920X1080P_59HZ_D963_A:
			return "TVIN_SIG_FMT_VGA_1920X1080P_59HZ_D963_A";
			break;
		case TVIN_SIG_FMT_VGA_1920X1080P_59HZ_D963:
			return "TVIN_SIG_FMT_VGA_1920X1080P_59D963";
			break;
		case TVIN_SIG_FMT_VGA_1920X1080P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1920X1080P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_1920X1200P_59HZ_D950:
			return "TVIN_SIG_FMT_VGA_1920X1200P_59D950";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000_C:
			return "TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000_C";
			break;
		case TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000_D:
			return "TVIN_SIG_FMT_VGA_1024X768P_60HZ_D000_D";
			break;
                case TVIN_SIG_FMT_VGA_1920X1200P_59HZ_D988:
                        return "TVIN_SIG_FMT_VGA_1920X1200P_59D988";
                        break;
		case TVIN_SIG_FMT_VGA_1400X900P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1400X900P_60D00";
			break;
		case TVIN_SIG_FMT_VGA_1680X1050P_60HZ_D000:
			return "TVIN_SIG_FMT_VGA_1680X1050P_60D000";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_60HZ_D062: //120
			return "TVIN_SIG_FMT_VGA_800X600P_60D062";
			break;
		case TVIN_SIG_FMT_VGA_800X600P_60HZ_317_B:
			return "TVIN_SIG_FMT_VGA_800X600P_60D317_B";
			break;
		case TVIN_SIG_FMT_VGA_RESERVE8:
			return "TVIN_SIG_FMT_VGA_RESERVE8";
			break;
		case TVIN_SIG_FMT_VGA_RESERVE9:
			return "TVIN_SIG_FMT_VGA_RESERVE9";
			break;
		case TVIN_SIG_FMT_VGA_RESERVE10:
			return "TVIN_SIG_FMT_VGA_RESERVE10";
			break;
		case TVIN_SIG_FMT_VGA_RESERVE11:
			return "TVIN_SIG_FMT_VGA_RESERVE11";
			break;
		case TVIN_SIG_FMT_VGA_RESERVE12: //126
			return "TVIN_SIG_FMT_VGA_RESERVE12";
			break;
		case TVIN_SIG_FMT_VGA_MAX:
			return "TVIN_SIG_FMT_VGA_MAX";
			break;
			//Component Formats
		case TVIN_SIG_FMT_COMP_480P_60HZ_D000:
			return "TVIN_SIG_FMT_COMP_480P_60D000";
			break;
		case TVIN_SIG_FMT_COMP_480I_59HZ_D940:
			return "TVIN_SIG_FMT_COMP_480I_59D940";
			break;
		case TVIN_SIG_FMT_COMP_576P_50HZ_D000:
			return "TVIN_SIG_FMT_COMP_576P_50D000";
			break;
		case TVIN_SIG_FMT_COMP_576I_50HZ_D000:
			return "TVIN_SIG_FMT_COMP_576I_50D000";
			break;
		case TVIN_SIG_FMT_COMP_720P_59HZ_D940:
			return "TVIN_SIG_FMT_COMP_720P_59D940";
			break;
		case TVIN_SIG_FMT_COMP_720P_50HZ_D000:
			return "TVIN_SIG_FMT_COMP_720P_50D000";
			break;
		case TVIN_SIG_FMT_COMP_1080P_23HZ_D976:
			return "TVIN_SIG_FMT_COMP_1080P_23D976";
			break;
		case TVIN_SIG_FMT_COMP_1080P_24HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080P_24D000";
			break;
		case TVIN_SIG_FMT_COMP_1080P_25HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080P_25D000";
			break;
		case TVIN_SIG_FMT_COMP_1080P_30HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080P_30D000";
			break;
		case TVIN_SIG_FMT_COMP_1080P_50HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080P_50D000";
			break;
		case TVIN_SIG_FMT_COMP_1080P_60HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080P_60D000";
			break;
		case TVIN_SIG_FMT_COMP_1080I_47HZ_D952:
			return "TVIN_SIG_FMT_COMP_1080I_47D952";
			break;
		case TVIN_SIG_FMT_COMP_1080I_48HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080I_48D000";
			break;
		case TVIN_SIG_FMT_COMP_1080I_50HZ_D000_A:
			return "TVIN_SIG_FMT_COMP_1080I_50D000_A";
			break;
		case TVIN_SIG_FMT_COMP_1080I_50HZ_D000_B:
			return "TVIN_SIG_FMT_COMP_1080I_50D000_B";
			break;
		case TVIN_SIG_FMT_COMP_1080I_50HZ_D000_C:
			return "TVIN_SIG_FMT_COMP_1080I_50D000_C";
			break;
		case TVIN_SIG_FMT_COMP_1080I_60HZ_D000:
			return "TVIN_SIG_FMT_COMP_1080I_60D000";
			break;
		case TVIN_SIG_FMT_COMP_MAX:
			return "TVIN_SIG_FMT_COMP_MAX";
			break;
			//HDMI Formats
		case TVIN_SIG_FMT_HDMI_640X480P_60HZ:
			return "TVIN_SIG_FMT_HDMI_640x480P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_720X480P_60HZ:
			return "TVIN_SIG_FMT_HDMI_720x480P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_60HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_60HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X480I_60HZ:
			return "TVIN_SIG_FMT_HDMI_1440x480I_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X240P_60HZ:
			return "TVIN_SIG_FMT_HDMI_1440x240P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_2880X480I_60HZ:
			return "TVIN_SIG_FMT_HDMI_2880x480I_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_2880X240P_60HZ:
			return "TVIN_SIG_FMT_HDMI_2880x240P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X480P_60HZ:
			return "TVIN_SIG_FMT_HDMI_1440x480P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_60HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_720X576P_50HZ:
			return "TVIN_SIG_FMT_HDMI_720x576P_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_50HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_50HZ_A:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_50Hz_A";
			break;
		case TVIN_SIG_FMT_HDMI_1440X576I_50HZ:
			return "TVIN_SIG_FMT_HDMI_1440x576I_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X288P_50HZ:
			return "TVIN_SIG_FMT_HDMI_1440x288P_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_2880X576I_50HZ:
			return "TVIN_SIG_FMT_HDMI_2880x576I_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_2880X288P_50HZ:
			return "TVIN_SIG_FMT_HDMI_2880x288P_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X576P_50HZ:
			return "TVIN_SIG_FMT_HDMI_1440x576P_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_50HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_50Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_24HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_24Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_25HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_25Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_30HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_30Hz";
			break;
		case TVIN_SIG_FMT_HDMI_2880X480P_60HZ:
			return "TVIN_SIG_FMT_HDMI_2880x480P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_2880X576P_60HZ:
			return "TVIN_SIG_FMT_HDMI_2880x576P_60Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_50HZ_B:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_50Hz_B";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_100HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_100Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_100HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_100Hz";
			break;
		case TVIN_SIG_FMT_HDMI_720X576P_100HZ:
			return "TVIN_SIG_FMT_HDMI_720x576P_100Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X576I_100HZ:
			return "TVIN_SIG_FMT_HDMI_1440x576I_100Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_120HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_120Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_120HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_120Hz";
			break;
		case TVIN_SIG_FMT_HDMI_720X480P_120HZ:
			return "TVIN_SIG_FMT_HDMI_720x480P_120Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X480I_120HZ:
			return "TVIN_SIG_FMT_HDMI_1440x480I_120Hz";
			break;
		case TVIN_SIG_FMT_HDMI_720X576P_200HZ:
			return "TVIN_SIG_FMT_HDMI_720x576P_200Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X576I_200HZ:
			return "TVIN_SIG_FMT_HDMI_1440x576I_200Hz";
			break;
		case TVIN_SIG_FMT_HDMI_720X480P_240HZ:
			return "TVIN_SIG_FMT_HDMI_720x480P_240Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1440X480I_240HZ:
			return "TVIN_SIG_FMT_HDMI_1440x480I_240Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_24HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_24Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_25HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_25Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_30HZ:
			return "TVIN_SIG_FMT_HDMI_1280x720P_30Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_120HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_120Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_100HZ:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_100Hz";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_60HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1280x720P_60Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_50HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1280x720P_50Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_24HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1280x720P_24Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1280X720P_30HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1280x720P_30Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_60HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_60Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080I_50HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1920x1080I_50Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_24HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_24Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_1920X1080P_30HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_1920x1080P_30Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_800X600_00HZ:
			return "TVIN_SIG_FMT_HDMI_800x600";
			break;
		case TVIN_SIG_FMT_HDMI_1024X768_00HZ:
			return "TVIN_SIG_FMT_HDMI_1024x768";
			break;
		case TVIN_SIG_FMT_HDMI_720X400_00HZ:
			return "TVIN_SIG_FMT_HDMI_720_400";
			break;
		case TVIN_SIG_FMT_HDMI_1280X768_00HZ:
			return "TVIN_SIG_FMT_HDMI_1280_768";
			break;
		case     TVIN_SIG_FMT_HDMI_1280X800_00HZ:
			return "TVIN_SIG_FMT_HDMI_1280_800";
			break;
		case     TVIN_SIG_FMT_HDMI_1280X960_00HZ:
			return "TVIN_SIG_FMT_HDMI_1280_960";
			break;
		case     TVIN_SIG_FMT_HDMI_1280X1024_00HZ:
			return "TVIN_SIG_FMT_HDMI_1280_1024";
			break;
		case     TVIN_SIG_FMT_HDMI_1360X768_00HZ:
			return "TVIN_SIG_FMT_HDMI_1360_768";
			break;
		case     TVIN_SIG_FMT_HDMI_1366X768_00HZ:
			return "TVIN_SIG_FMT_HDMI_1366_768";
			break;
		case     TVIN_SIG_FMT_HDMI_1600X1200_00HZ:
			return "TVIN_SIG_FMT_HDMI_1600_1200";
			break;
		case     TVIN_SIG_FMT_HDMI_1920X1200_00HZ:
			return "TVIN_SIG_FMT_HDMI_1920_1200";
			break;
		case     TVIN_SIG_FMT_HDMI_1440X900_00HZ:
			return "TVIN_SIG_FMT_HDMI_1440X900_00HZ";
			break;
		case     TVIN_SIG_FMT_HDMI_1400X1050_00HZ:
			return "TVIN_SIG_FMT_HDMI_1400X1050_00HZ";
			break;
		case     TVIN_SIG_FMT_HDMI_1680X1050_00HZ:
			return "TVIN_SIG_FMT_HDMI_1680X1050_00HZ";
			break;
			/* for alternative and 4k2k */
		case     TVIN_SIG_FMT_HDMI_1920X1080I_60HZ_ALTERNATIVE:
			return "TVIN_SIG_FMT_HDMI_1920X1080I_60HZ_ALTERNATIVE";
			break;
       case     TVIN_SIG_FMT_HDMI_1920X1080I_50HZ_ALTERNATIVE:
            return "TVIN_SIG_FMT_HDMI_1920X1080I_50HZ_ALTERNATIVE";
            break;
		case     TVIN_SIG_FMT_HDMI_1920X1080P_24HZ_ALTERNATIVE:
		    return "TVIN_SIG_FMT_HDMI_1920X1080P_24HZ_ALTERNATIVE";
		    break;
       case     TVIN_SIG_FMT_HDMI_1920X1080P_30HZ_ALTERNATIVE:
            return "TVIN_SIG_FMT_HDMI_1920X1080P_30HZ_ALTERNATIVE";
            break;
		case     TVIN_SIG_FMT_HDMI_3840_2160_00HZ:
			return "TVIN_SIG_FMT_HDMI_3840_2160_00HZ";
			break;
		case     TVIN_SIG_FMT_HDMI_4096_2160_00HZ:
			return "TVIN_SIG_FMT_HDMI_4096_2160_00HZ";
			break;
		case     TVIN_SIG_FMT_HDMI_RESERVE7:
			return "TVIN_SIG_FMT_HDMI_RESERVE7";
			break;
		case     TVIN_SIG_FMT_HDMI_RESERVE8:
			return "TVIN_SIG_FMT_HDMI_RESERVE8";
			break;
		case     TVIN_SIG_FMT_HDMI_RESERVE9:
			return "TVIN_SIG_FMT_HDMI_RESERVE9";
			break;
		case     TVIN_SIG_FMT_HDMI_RESERVE10:
			return "TVIN_SIG_FMT_HDMI_RESERVE10";
			break;
		case     TVIN_SIG_FMT_HDMI_RESERVE11:
			return "TVIN_SIG_FMT_HDMI_RESERVE11";
			break;
		case     TVIN_SIG_FMT_HDMI_720X480P_60HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_720x480P_60Hz_FRAME_PACKING";
			break;
		case     TVIN_SIG_FMT_HDMI_720X576P_50HZ_FRAME_PACKING:
			return "TVIN_SIG_FMT_HDMI_720x576P_50Hz_FRAME_PACKING";
			break;
		case TVIN_SIG_FMT_HDMI_MAX:
			return "TVIN_SIG_FMT_HDMI_MAX";
			break;
			//Video Formats
		case TVIN_SIG_FMT_CVBS_NTSC_M:
			return "TVIN_SIG_FMT_CVBS_NTSC_M";
			break;
		case TVIN_SIG_FMT_CVBS_NTSC_443:
			return "TVIN_SIG_FMT_CVBS_NTSC_443";
			break;
		case TVIN_SIG_FMT_CVBS_PAL_I:
			return "TVIN_SIG_FMT_CVBS_PAL_I";
			break;
		case TVIN_SIG_FMT_CVBS_PAL_M:
			return "TVIN_SIG_FMT_CVBS_PAL_M";
			break;
		case TVIN_SIG_FMT_CVBS_PAL_60:
			return "TVIN_SIG_FMT_CVBS_PAL_60";
			break;
		case TVIN_SIG_FMT_CVBS_PAL_CN:
			return "TVIN_SIG_FMT_CVBS_PAL_CN";
			break;
		case TVIN_SIG_FMT_CVBS_SECAM:
			return "TVIN_SIG_FMT_CVBS_SECAM";
			break;
			//656 Formats
		case TVIN_SIG_FMT_BT656IN_576I_50HZ:
			return "TVIN_SIG_FMT_BT656IN_576I";
			break;
		case TVIN_SIG_FMT_BT656IN_480I_60HZ:
			return "TVIN_SIG_FMT_BT656IN_480I";
			break;
			//601 Formats
		case TVIN_SIG_FMT_BT601IN_576I_50HZ:
			return "TVIN_SIG_FMT_BT601IN_576I";
			break;
		case TVIN_SIG_FMT_BT601IN_480I_60HZ:
			return "TVIN_SIG_FMT_BT601IN_480I";
			break;
			//Camera Formats
		case TVIN_SIG_FMT_CAMERA_640X480P_30HZ:
			return "TVIN_SIG_FMT_CAMERA_640X480P_30Hz";
			break;
		case TVIN_SIG_FMT_CAMERA_800X600P_30HZ:
			return "TVIN_SIG_FMT_CAMERA_800X600P_30Hz";
			break;
		case TVIN_SIG_FMT_CAMERA_1024X768P_30HZ:
			return "TVIN_SIG_FMT_CAMERA_1024X768P_30Hz";
			break;
		case TVIN_SIG_FMT_CAMERA_1920X1080P_30HZ:
			return "TVIN_SIG_FMT_CAMERA_1920X1080P_30Hz";
			break;
		case TVIN_SIG_FMT_CAMERA_1280X720P_30HZ:
			return "TVIN_SIG_FMT_CAMERA_1280X720P_30Hz";
			break;
		case TVIN_SIG_FMT_MAX:
			return "TVIN_SIG_FMT_MAX";
			break;
		default:
			return "TVIN_SIG_FMT_NULL";
			break;
	}
}
EXPORT_SYMBOL(tvin_sig_fmt_str);


const struct tvin_format_s *tvin_get_fmt_info(enum tvin_sig_fmt_e fmt)
{
	//find  format table through format
	if (fmt < TVIN_SIG_FMT_VGA_MAX && fmt > TVIN_SIG_FMT_NULL)
		return &tvin_vga_fmt_tbl[fmt-TVIN_SIG_FMT_VGA_512X384P_60HZ_D147];
	else if (fmt < TVIN_SIG_FMT_COMP_MAX && fmt > TVIN_SIG_FMT_VGA_THRESHOLD)
		return  &tvin_comp_fmt_tbl[fmt-TVIN_SIG_FMT_COMP_480P_60HZ_D000];
	else if (fmt < TVIN_SIG_FMT_HDMI_MAX && fmt > TVIN_SIG_FMT_COMP_THRESHOLD)
		return &tvin_hdmi_fmt_tbl[fmt-TVIN_SIG_FMT_HDMI_640X480P_60HZ];
	else if (fmt < TVIN_SIG_FMT_CVBS_MAX && fmt > TVIN_SIG_FMT_HDMI_THRESHOLD)
		return &tvin_cvbs_fmt_tbl[fmt-TVIN_SIG_FMT_CVBS_NTSC_M];
	else if (fmt < TVIN_SIG_FMT_BT601_MAX && fmt > TVIN_SIG_FMT_CVBS_THRESHOLD)
		return &tvin_bt601_fmt_tbl[fmt-TVIN_SIG_FMT_BT656IN_576I_50HZ];
    else
        return NULL;
	//we also can find  format table through port
	/*
	   if(port != TVIN_PORT_NULL)
	   {
	   if ((port >= TVIN_PORT_VGA0) && (port < TVIN_PORT_VGA7))
	   return &tvin_vga_fmt_tbl[fmt-TVIN_SIG_FMT_VGA_512X384P_60HZ_D147];
	   else if ((port >= TVIN_PORT_COMP0) && (port < TVIN_PORT_COMP7))
	   return  &tvin_comp_fmt_tbl[fmt-TVIN_SIG_FMT_COMP_480P_60HZ_D000];
	   else if ((port >= TVIN_PORT_CVBS0) && (port <= TVIN_PORT_SVIDEO7))
	   return &tvin_cvbs_fmt_tbl[fmt-TVIN_SIG_FMT_CVBS_NTSC_M];
	   else if ((port >= TVIN_PORT_HDMI0) && (port <= TVIN_PORT_HDMI7))
	   return &tvin_hdmi_fmt_tbl[fmt-TVIN_SIG_FMT_HDMI_640X480P_60HZ];
	   else if ((port >= TVIN_PORT_BT656) && (port <= TVIN_PORT_CAMERA))
	   return &tvin_bt601_fmt_tbl[fmt-TVIN_SIG_FMT_BT656IN_576I_50HZ];
	   }
	 */
}
EXPORT_SYMBOL(tvin_get_fmt_info);

const struct tvin_format_s tvin_vga_fmt_tbl[TVIN_SIG_FMT_VGA_MAX - TVIN_SIG_FMT_VGA_512X384P_60HZ_D147 + 1] =
{
	//   H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity             Vs_Polarity             Scan_Mode                   Pixel_Clk(Khz/10) VBIs VBIe
	{ 512,     384,      0 ,        10,    10,       49 ,        10,    640,    407,     16,     32,     80,       1,       3,   19,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  1567,   0,   0, 1596 }, // TVIN_SIG_FMT_VGA_512X384P_60D147,
	{ 560,     384,      0 ,        10,    10,       67 ,        10,    704,    407,     16,     48,     80,       1,       3,   19,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  1723,   0,   0, 1596 }, // TVIN_SIG_FMT_VGA_560X384P_60D147,
	{ 640,     200,      0 ,        10,    10,       94 ,        10,    912,    262,     94,     56,    122,      25,       3,   34,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  1432,   0,   0, 1602 }, // TVIN_SIG_FMT_VGA_640X200P_59D924,
	{ 640,     350,      0 ,        10,    10,       49 ,        10,    832,    445,     32,     64,     96,      32,       3,   60,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3150,   0,   0, 1128 }, // TVIN_SIG_FMT_VGA_640X350P_85D080,
	{ 640,     400,      0 ,        10,    10,       92 ,         2,    800,    525,     16,     96,     48,      50,       2,   73,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2517,   0,   0, 1602 }, // TVIN_SIG_FMT_VGA_640X400P_59D940,
	{ 640,     400,      0 ,        10,    10,       49 ,        10,    832,    445,     32,     64,     96,       1,       3,   41,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3150,   0,   0, 1128 }, // TVIN_SIG_FMT_VGA_640X400P_85D080,
	{ 640,     400,      0 ,        10,    10,       111,        10,    824,    508,      3,    115,     66,      42,       2,   64,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2496,   0,   0, 1610 }, // TVIN_SIG_FMT_VGA_640X400P_59D638,
	{ 640,     400,      0 ,        10,    10,       73 ,        10,    848,    440,     64,     64,     80,       7,       8,   25,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2105,   0,   0, 1702 }, // TVIN_SIG_FMT_VGA_640X400P_56D416,
	{ 640,     480,      0 ,        10,    10,       49 ,        10,    896,    525,     80,     64,    112,       3,       3,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3134,   0,   0, 1441 }, // TVIN_SIG_FMT_VGA_640X480P_66D619,
	{ 640,     480,      0 ,        10,    10,       51 ,        10,    864,    525,     64,     64,     96,       3,       3,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3024,   0,   0, 1440 }, // TVIN_SIG_FMT_VGA_640X480P_66D667,   // 10
	{ 640,     480,    762 ,        10,    10,       65 ,        10,    800,    525,     16,     96,     48,      10,       2,   33,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2517,   0,   0, 1602 }, // TVIN_SIG_FMT_VGA_640X480P_59D940,
	{ 640,     480,    762 ,        10,    10,       91 ,         2,    800,    525,     16,     76,     48,      10,       2,   33,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2520,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_640X480P_60D000,
	{ 640,     480,    634 ,        10,    10,       30 ,        10,    832,    520,     24,     40,    108,       9,       3,   28,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3150,   0,   0, 1319 }, // TVIN_SIG_FMT_VGA_640X480P_72D809,
	{ 640,     480,    640 ,        10,    10,       49 ,        10,    840,    500,     16,     64,    120,       1,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3150,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_640X480P_75D000_A,
	{ 640,     480,      0 ,        10,    10,       37 ,        10,    832,    509,     56,     56,     80,       1,       3,   25,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3600,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_640X480P_85D008,
	{ 640,     480,    792 ,        10,    10,       105,        10,    826,    508,      3,    110,     73,       4,       2,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2502,   0,   0, 1610 }, // TVIN_SIG_FMT_VGA_640X480P_59D638,
	{ 640,     480,      0 ,        10,    10,       73 ,        10,    800,    525,     16,     96,     48,      11,       2,   32,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3150,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_640X480P_75D000_B,
	{ 640,     870,      0 ,        10,    10,       34 ,        10,    832,    918,     32,     80,     80,       3,       3,   42,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5728,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_640X870P_75D000,
	{ 720,     350,      0 ,        10,    10,       92 ,        10,    900,    449,     18,    108,     54,      37,       2,   60,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2832,   0,   0, 1370 }, // TVIN_SIG_FMT_VGA_720X350P_70D086,
	{ 720,     400,      0 ,        10,    10,       49 ,        10,    936,    446,     36,     72,    108,       1,       3,   42,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3550,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_720X400P_85D039,   // 20
	{ 720,     400,    763 ,        10,    10,       92 ,        10,    900,    449,     18,    108,     54,      12,       2,   35,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2832,   0,   0, 1370 }, // TVIN_SIG_FMT_VGA_720X400P_70D086,
	{ 720,     400,      0 ,        10,    10,       73 ,        10,    900,    449,     18,    108,     54,      21,       2,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3550,   0,   0, 1093 }, // TVIN_SIG_FMT_VGA_720X400P_87D849,
	{ 720,     400,      0 ,        10,    10,       92 ,        10,    900,    525,     18,    108,     54,      50,       2,   73,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2832,   0,   0, 1602 }, // TVIN_SIG_FMT_VGA_720X400P_59D940,
	{ 720,     480,    762 ,        10,    10,       55 ,        10,    858,    525,     16,     62,     60,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2657,   0,   0, 1602 }, // TVIN_SIG_FMT_VGA_720X480P_59D940,
	{ 768,     480,    801 ,        10,    10,       60 ,        10,    960,    500,     24,     72,     96,       3,       6,   11,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2875,   0,   0, 1603 }, // TVIN_SIG_FMT_VGA_768X480P_59D896,
	//H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity             Vs_Polarity             Scan_Mode                   Pixel_Clk(Khz/10) VBIs VBIe
	{ 800,     600,    682 ,        10,    10,       48 ,        10,   1024,    625,     24,     72,    128,       1,       2,   22,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3600,   0,   0, 1707 }, // TVIN_SIG_FMT_VGA_800X600P_56D250,
	{ 800,     600,    634 ,        10,    10,       30 ,        50,   1024,    622,     32,     80,    112,       1,       4,   17,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  3812,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_800X600P_60D000,
	{ 800,     600,    547 ,        10,    10,       42 ,        10,   1040,    625,     64,     68,    108,       3,       3,   19,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4000,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_800X600P_60D000_A,
	{ 800,     600,    634 ,        10,    10,       77 ,        10,   1056,    628,     40,    128,     88,       1,       4,   23,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4000,   0,   0, 1592 }, // TVIN_SIG_FMT_VGA_800X600P_60D317,
	{ 800,     600,    499 ,        10,    10,       58 ,        10,   1040,    666,     56,    120,     64,      37,       6,   23,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5000,   0,   0, 1330 }, // TVIN_SIG_FMT_VGA_800X600P_72D188,   //30
	{ 800,     600,    512 ,        10,    10,       39 ,        10,   1056,    625,     16,     80,    160,       1,       3,   21,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4950,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_800X600P_75D000,
	{ 800,     600,    447 ,        10,    10,       27 ,        10,   1048,    631,     32,     64,    152,       1,       3,   27,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5625,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_800X600P_85D061,
	{ 832,     624,      0 ,        10,    10,       42 ,        10,   1120,    654,     32,     96,    160,       3,       3,   24,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5500,   0,   0, 1279 }, // TVIN_SIG_FMT_VGA_832X624P_75D087,
	{ 848,     480,      0 ,        10,    10,       41 ,        10,   1088,    507,     40,     80,    120,       3,       5,   19,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4675,   0,   0, 1133 }, // TVIN_SIG_FMT_VGA_848X480P_84D751,
	{ 960,     600,    645 ,        10,    10,       51 ,        10,   1216,    624,     32,     96,    128,       3,       6,   15,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4525,   0,   0, 1610 }, // TVIN_SIG_FMT_VGA_960X600P_59D635,
	{1024,     768,    349 ,        10,    10,       27 ,        10,   1344,    807,     96,     80,    144,       9,       1,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6400,   0,   0, 1619 }, // TVIN_SIG_FMT_VGA_1024X768P_59D278,
	{1024,     768,    355 ,        10,    10,        0 ,        10,   1328,   1120,     80,     80,    144,      11,       4,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6400,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1024X768P_60D000,
	{1024,     768,    495 ,         8,     6,       35 ,        35,   1344,    806,     56,    120,    144,       1,       6,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1024X768P_60D000_A,//for hdmi and vga
	{1024,     768,    495 ,         8,     8,       50 ,        10,   1344,    806,     56,    120,    144,       1,       6,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1024X768P_60D000_B,//for hdmi and vga
	{1024,     768,    398 ,        10,    10,       29 ,        10,   1328,    804,     32,     96,    176,       3,       3,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8000,   0,   0, 1281 }, // TVIN_SIG_FMT_VGA_1024X768P_74D927,  //40
	{1024,     768,    496 ,        10,    10,       50 ,        10,   1344,    806,     24,    136,    140,       3,       6,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6500,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1024X768P_60D004,
	{1024,     768,    425 ,        10,    10,       44 ,        10,   1328,    806,     24,    136,    124,       3,       6,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7500,   0,   0, 1370 }, // TVIN_SIG_FMT_VGA_1024X768P_70D069,
	{1024,     768,    400 ,        10,    10,       29 ,        10,   1312,    800,     16,     96,    176,       1,       3,   28,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7875,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_1024X768P_75D029,
	{1024,     768,      0 ,        10,    10,       24 ,        10,   1376,    808,     48,     96,    208,       1,       3,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_1024X768P_84D997,
	{1024,     768,    381 ,        10,    10,       36 ,        10,   1344,    840,     64,    128,    128,       4,       4,   64,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8459,   0,   0, 1281 }, // TVIN_SIG_FMT_VGA_1024X768P_74D925,
	{1024,	   768,    495 ,	 8,	6,	 29 ,	     35,   1344,    806,     16,    90,    124,       1,	6,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,	 0,   0, 1600 },// TVIN_SIG_FMT_VGA_1024X768P_60D020,
	{1024,     768,      501 ,        10,    10,       39 ,        10,   1328,    798,     18,    104,     153,       2,       4,   23,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6350,   0,   0, 1371 }, // TVIN_SIG_FMT_VGA_1024X768P_70D008,
	{1024,     768,      0 ,        10,    10,       89 ,        10,   1408,    806,      8,    320,     56,       0,       8,   30,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8600,   0,   0, 1267 }, // TVIN_SIG_FMT_VGA_1024X768P_75D782,
	{1024,     768,      0 ,        10,    10,       36 ,        10,   1360,    805,     32,    128,    176,       2,       4,   31,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8437,   0,   0, 1246 }, // TVIN_SIG_FMT_VGA_1024X768P_77D069,
	{1024,     768,      0 ,        10,    10,       44 ,        10,   1296,    806,     24,    136,    112,       3,       6,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7500,   0,   0, 1337 }, // TVIN_SIG_FMT_VGA_1024X768P_71D799,   //50
	{1024,    1024,      0 ,        10,    10,       43 ,        10,   1408,   1056,     21,    160,    203,       3,       3,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8921,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1024X1024P_60D000,
	{1152,     864,    446 ,        10,    10,       36 ,        10,   1520,    895,     54,     96,    172,       16,      3,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1152X864P_60D000,
	{1152,     864,      0 ,        10,    10,       24 ,        10,   1480,    912,     32,     96,    200,       1,       3,   44,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,   0,   0, 1371 }, // TVIN_SIG_FMT_VGA_1152X864P_70D012,
	{1152,     864,      0 ,        10,    10,       28 ,        10,   1600,    900,     64,    128,    256,       1,       3,   32,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_1152X864P_75D000,
	{1152,     864,      0 ,        10,    10,       25 ,        10,   1576,    907,     64,    128,    232,       1,       3,   39,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 12150,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_1152X864P_84D999,
	{1152,     870,      0 ,        10,    10,       31 ,        10,   1456,    915,     32,    128,    144,       3,       3,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10000,   0,   0, 1279 }, // TVIN_SIG_FMT_VGA_1152X870P_75D062,
	{1152,     900,      0 ,        10,    10,       33 ,        10,   1504,    937,     29,    128,    195,       2,       4,   31,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9294,   0,   0, 1456 }, // TVIN_SIG_FMT_VGA_1152X900P_65D950,
	{1152,     900,      0 ,        10,    10,       33 ,        10,   1528,    937,     40,    128,    208,       2,       4,   31,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  9450,   0,   0, 1454 }, // TVIN_SIG_FMT_VGA_1152X900P_66D004,
	{1152,     900,      0 ,        10,    10,       22 ,        10,   1472,    943,     16,     96,    208,       2,       8,   33,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10556,   0,   0, 1262 }, // TVIN_SIG_FMT_VGA_1152X900P_76D047,
	{1152,     900,      0 ,        10,    10,       28 ,        10,   1504,    943,     32,    128,    192,       2,       8,   33,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1261 }, // TVIN_SIG_FMT_VGA_1152X900P_76D149,   //60
	{1280,     720,    536 ,        10,    10,       41 ,        10,   1664,    748,     64,    128,    192,       3,       5,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7450,   0,   0, 1604 }, // TVIN_SIG_FMT_VGA_1280X720P_59D855,
	{1280,     720,    536 ,        10,    10,       13 ,        10,   1664,    748,     64,    128,    192,       4,       4,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X720P_60D000_A,
	{1280,     720,    536 ,        10,    10,       41 ,        10,   1664,    748,     64,    128,    192,       3,       5,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X720P_60D000_B,
	{1280,     720,    532 ,        10,    10,       13 ,        10,   1650,    748,     100,    78,    192,       4,       4,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X720P_60D000_C,
	{1280,     720,    372 ,        10,    10,       30 ,        10,   1664,    755,     64,    128,    192,      12,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7450,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X720P_60D000_D,
	{1280,     768,    502 ,        10,    10,       39 ,        10,   1664,    798,     64,    128,    192,       3,       7,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7950,   0,   0, 1603 }, // TVIN_SIG_FMT_VGA_1280X768P_59D870,
	{1280,     768,    506 ,        10,    10,       11 ,        10,   1440,    790,     48,     32,     80,       3,       7,   12,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6825,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X768P_59D995,
	{1280,     768,    502 ,        10,    10,       39 ,        10,   1680,    795,     64,    136,    200,       4,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7950,   0,   0, 1597 }, // TVIN_SIG_FMT_VGA_1280X768P_60D100,
	{1280,     768,    349 ,        10,    10,       29 ,        10,   1712,    808,    132,    118,    182,      13,       7,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7950,   0,   0, 1597 }, /// TVIN_SIG_FMT_VGA_1280X768P_85D000,
	{1280,     768,      0 ,        10,    10,       30 ,        10,   1696,    805,     80,    128,    208,       3,       7,   27,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10225,   0,   0, 1282 }, // TVIN_SIG_FMT_VGA_1280X768P_74D893,   //70
	{1280,     768,      0 ,        10,    10,       28 ,        10,   1712,    809,     80,    136,    216,       3,       7,   31,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 11750,   0,   0, 1132 }, // TVIN_SIG_FMT_VGA_1280X768P_84D837,
	{1280,     800,    483 ,        10,    10,       37 ,        10,   1680,    831,     72,    128,    200,       3,       6,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8350,   0,   0, 1605 }, // TVIN_SIG_FMT_VGA_1280X800P_59D810,
	{1280,     800,    483 ,        10,    10,       40 ,        10,   1680,    827,     72,    128,    200,       2,       3,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8350,   0,   0, 1605 }, // TVIN_SIG_FMT_VGA_1280X800P_59D810_A,
	{1280,     800,    334 ,        10,    10,       26 ,        10,   1680,    843,     72,    128,    200,      18,       3,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8350,   0,   0, 1605 }, // TVIN_SIG_FMT_VGA_1280X800P_60D000,
	{1280,     800,    334 ,        10,    10,       26 ,        10,   1712,    843,     80,    136,    216,       3,       6,   34,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8350,   0,   0, 1605 }, // TVIN_SIG_FMT_VGA_1280X800P_85D000,
	{1280,     960,    399 ,        10,    10,       25 ,        5,   1800,   1000,     96,    112,    312,       1,       3,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X960P_60D000,
	{1280,     960,    399 ,        10,    10,       25 ,        10,   1712,   994,     80,    136,    216,       1,       3,   29,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X960P_60D000_A,
	{1280,     960,      0 ,        10,    10,       27 ,        10,   1680,   1000,     32,    144,    224,       1,       3,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 12600,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_1280X960P_75D000,
	{1280,     960,      0 ,        10,    10,       26 ,        10,   1728,   1011,     64,    160,    224,       1,       3,   47,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_1280X960P_85D002,
	{1280,    1024,    375 ,        10,    10,       25 ,         2,   1688,   1066,     48,    112,    248,       1,       3,   38,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1599 }, // TVIN_SIG_FMT_VGA_1280X1024P_60D020,  //80
	{1280,    1024,    375 ,        10,     5,       25 ,         4,   1696,   1066,     92,    112,    212,       1,       3,   38,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1599 }, // TVIN_SIG_FMT_VGA_1280X1024P_60D020_A,
	{1280,    1024,    300 ,        10,    10,       26 ,        10,   1688,   1066,     16,    144,    248,       1,       3,   38,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 13500,   0,   0, 1280 }, // TVIN_SIG_FMT_VGA_1280X1024P_75D025,
	{1280,    1024,      0 ,        10,    10,       24 ,        10,   1728,   1072,     64,    160,    224,       1,       3,   44,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 15750,   0,   0, 1129 }, // TVIN_SIG_FMT_VGA_1280X1024P_85D024,
	{1280,    1024,      0 ,        10,    10,       41 ,        10,   1708,   1056,     44,    184,    200,       3,       3,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10818,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1280X1024P_59D979,
	{1280,    1024,      0 ,        10,    10,       34 ,        10,   1728,   1085,     64,    192,    192,       3,       3,   55,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 13500,   0,   0, 1333 }, // TVIN_SIG_FMT_VGA_1280X1024P_72D005,
	{1280,    1024,      0 ,        10,    10,       43 ,        10,   1760,   1056,     26,    200,    254,       3,       3,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 11152,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X1024P_60D002,
	{1280,    1024,      0 ,        10,    10,       32 ,        10,   1696,   1056,     32,    160,    224,       3,       3,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 12000,   0,   0, 1433 }, // TVIN_SIG_FMT_VGA_1280X1024P_67D003,
	{1280,    1024,      0 ,        10,    10,       26 ,        10,   1712,   1064,     32,    144,    256,       3,       3,   34,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 13500,   0,   0, 1295 }, // TVIN_SIG_FMT_VGA_1280X1024P_74D112,
	{1280,    1024,      0 ,        10,    10,       17 ,        10,   1724,   1066,     32,    100,    312,       3,       3,   36,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14000,   0,   0, 1260 }, // TVIN_SIG_FMT_VGA_1280X1024P_76D179,
	{1280,    1024,      0 ,        10,    10,       23 ,        10,   1632,   1075,     16,    112,    224,       6,       8,   37,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 11705,   0,   0, 1439 }, // TVIN_SIG_FMT_VGA_1280X1024P_66D718,  //90
	{1280,    1024,      0 ,        10,    10,       26 ,        10,   1648,   1075,     24,    128,    216,       2,       8,   41,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 11812,   0,   0, 1440 }, // TVIN_SIG_FMT_VGA_1280X1024P_66D677,
	{1280,    1024,      0 ,        10,    10,       11 ,        10,   1664,   1066,     32,     64,    288,       2,       8,   32,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 13500,   0,   0, 1261 }, // TVIN_SIG_FMT_VGA_1280X1024P_76D107,
	{1280,    1024,      0 ,        10,    10,       25 ,        10,   1688,   1065,     48,    112,    248,       1,       3,   37,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10786,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X1024P_59D996,
	{1280,    1024,    374 ,        10,    10,        0 ,        10,   1688,   1065,     48,    112,    248,       2,       2,   37,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10786,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1280X1024P_60D000,
	{1360,     768,    349 ,        10,    10,       28 ,        10,   1824,    806,    130,    126,    208,      12,       4,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8475,   0,   0, 1605 }, // TVIN_SIG_FMT_VGA_1360X768P_59D799,
	{1360,     768,    503 ,        10,    10,       32 ,         7,   1792,    795,     64,    112,    256,       3,       6,   18,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8550,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1360X768P_60D015,
	{1360,     768,    503 ,        7 ,     8,        32 ,         7,   1792,    795,    104,    112,    216,       3,       6,   18,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8550,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1360X768P_60D015_A,
	{1360,     850,    454 ,        10,    10,       37 ,        10,   1776,    879,     72,    136,    208,       3,       5,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8475,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1360X850P_60D000,
	{1360,    1024,   377  ,        10,    10,       30 ,        10,   1776,   1059,     72,    136,    208,       8,       5,   22,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8475,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1360X1024P_60D000,
	{1366,     768,    503 ,        10,    10,       40 ,        10,   1790,    798,     64,    143,    217,       3,       3,   24,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  8550,   0,   0, 1606 }, // TVIN_SIG_FMT_VGA_1366X768P_59D790,  //100
	{1366,     768,    500 ,        10,    10,       22 ,        10,   1500,    800,     14,     56,     64,       1,       3,   28,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7200,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1366X768P_60D000,
	{1400,    1050,   367  ,        10,    10,       28 ,        10,   1878,   1089,     88,    144,    232,       3,       4,   32,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 12175,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1400X1050P_59D978,
	{1440,     900,    429 ,        10,    10,       34 ,        10,   1904,    934,    80,    152,    232,       3,       5,   25,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10650,   0,   0, 1603 }, // TVIN_SIG_FMT_VGA_1440X900P_59D887,
	{1440,    1080,      0 ,        10,    10,       28 ,        10,   1936,   1118,     96,    152,    248,       1,       3,   34,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 12987,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1440X1080P_60D000,
	{1600,     900,    298 ,        10,    10,       23 ,        10,   2160,    945,     64,    192,    304,       1,       3,   41,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 16200,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1600X900P_60D000,
	{1600,    1024,   261  ,        10,    10,       21 ,        10,   2160,   1075,     64,    192,    304,       2,       3,   46,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 16200,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1600X1024P_60D000,
	{1600,    1200,   321  ,        10,     3,       25 ,        10,   2150,   1246,     64,    182,    304,       1,       4,   46,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 16100,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1600X1200P_59D869,
	{1600,    1200,   320  ,        10,    10,       28 ,        10,   2160,   1250,     64,    192,    304,       1,       3,   46,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 16200,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1600X1200P_60D000,
	{1600,    900,      338 ,        10,    10,       26 ,        10,   2136,   940,     64,    162,    234,       1,       3,   46,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 17550,   0,   0, 1477 }, // TVIN_SIG_FMT_VGA_1600X1200P_65D000,
	{1600,    1200,   274  ,        10,    10,       24 ,        10,   2160,   1250,     64,    192,    304,       1,       3,   46,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 18900,   0,   0, 1371 }, // TVIN_SIG_FMT_VGA_1600X1200P_70D000,
	{1680,    1050,   367 ,        10 ,    10,       28 ,        10,   2240,   1089,    104,    176,    280,       3,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14625,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1680X1050P_59D954,  //110
	{1680,    1080,      0 ,        10,    10,       29 ,        10,   2256,   1118,    104,    184,    288,       1,       3,   34,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 15133,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1680X1080P_60D000,
	{1920,    1080,   431  ,        10,    10,       34 ,        10,   2543,   1114,    112,    200,    312,       3,       5,   26,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14150,   0,   0, 1923 }, // TVIN_SIG_FMT_VGA_1920X1080P_49D929,
	{1920,    1080,   357  ,        10,    10,       28 ,        10,   2576,   1120,    152,    200,    304,       5,       3,   32,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 17280,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1920X1080P_59D963_A,
	{1920,    1080,   357  ,        10,    10,       28 ,        10,   2574,   1120,    128,    200,    328,       3,       5,   32,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 17280,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1920X1080P_59D963,
	{1920,    1080,   356  ,        10,    10,        7 ,        10,   2200,   1125,     72,     88,    120,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1920X1080P_60D000,
	{1920,    1200,    324 ,        10,    10,        5 ,        10,   2080,   1235,     48,    32,      80,       3,       6,   26,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 15400,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1920X1200P_59D950,//116
	{1024,     768,    495 ,        10,    10,       76 ,        10,   1350,    805,     26,    244,     46,      1,       3,    33,    TVIN_SYNC_POL_NEGATIVE,     TVIN_SYNC_POL_NEGATIVE,    TVIN_SCAN_MODE_PROGRESSIVE, 10237,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_1024x768P_60D000_C,
	{1024,     768,    496 ,        10,    10,       50 ,        10,   1344,    806,     24,    136,    160,       3,       6,   29,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6500,   0,   0, 1600 }, //TVIN_SIG_FMT_VGA_1024x768P_60D000_D,
	{1920,    1200,    320 ,        10,    10,        25,        10,   2592,   1242,    136,    200,    336,       3,       4,   36,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 19325,   0,   0, 1601 }, // TVIN_SIG_FMT_VGA_1920X1200P_59D988, //120
	{1440,	   900,	    432,	10,	10,	   9,	     10,   1600,   926 ,     48,    32,	     80,       3,	6,   17,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE,TVIN_SCAN_MODE_PROGRESSIVE,  8875,   0,	0,  1600},//TVIN_SIG_FMT_VGA_1400X900P_60D00,
	{1680,	  1050,    370 , 	10,	10,	  7 ,	     10,   1840,   1080,     48,    32,      80,       3,	6,   21,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 11900,	0,	 0, 1600 }, // TVIN_SIG_FMT_VGA_1680X1050P_60D000,
	{ 800,	   600,    634 ,	10,    10,	 55 ,	     10,   1056,    628,     40,    88,      68,       1,	4,   23,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4000,	 0,   0, 1592 }, // TVIN_SIG_FMT_VGA_800X600P_60D062,
	{ 800,	   600,    634 ,	10,    10,	 77 ,	     10,   1056,    628,     40,    128,     88,       1,	4,   23,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4000,	 0,   0, 1592 }, // TVIN_SIG_FMT_VGA_800X600P_60D317_B,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_RESERVE8,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_RESERVE9,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_RESERVE10,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_RESERVE11,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_RESERVE12,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_VGA_MAX,
};

const struct tvin_format_s tvin_comp_fmt_tbl[TVIN_SIG_FMT_COMP_MAX - TVIN_SIG_FMT_COMP_480P_60HZ_D000 + 1] =
{
	//   H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity             Vs_Polarity             Scan_Mode                   Pixel_Clk(Khz/10) VBIs VBIe
#ifdef CONFIG_ADC_DOUBLE_SAMPLING_FOR_SD
	{1440,     480,    762 ,        20,    20,       55 ,        10,   1716,    525,     32,    124,    120,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_PROGRESSIVE, 5406,   0,   0, 1600 }, // TVIN_SIG_FMT_COMPONENT_480P_60D000,
	{1440,     240,    1525,        20,    20,       110,        10,   1716,    263,     38,    124,    114,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,   2700,   0,   0, 1602 }, // TVIN_SIG_FMT_COMPONENT_480I_59D940,
	{1440,     576,    768 ,        20,    20,       57 ,        10,   1728,    625,     24,    128,    136,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_PROGRESSIVE, 5400,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_576P_50D000,
	{1440,     288,    1536,        20,    20,       112,        10,   1728,    313,     24,    126,    138,       2,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,   2700,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_576I_50D000,
#else
	{ 720,     480,    762 ,        20,    20,       55 ,        10,    858,    525,     16,     62,     60,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_PROGRESSIVE, 2703,   0,   0, 1600 }, // TVIN_SIG_FMT_COMPONENT_480P_60D000,
	{ 720,     240,    1525,        20,    20,       110,        10,    858,    263,     19,     62,     57,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,   1350,   0,   0, 1602 }, // TVIN_SIG_FMT_COMPONENT_480I_59D940,
	{ 720,     576,    768 ,        20,    20,       57 ,        10,    864,    625,     12,     64,     68,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_PROGRESSIVE, 2700,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_576P_50D000,
	{ 720,     288,    1536,        20,    20,       112,        10,    864,    313,     12,     63,     69,       2,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,   1350,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_576I_50D000,
#endif
	{1280,     720,    534 ,        10,    20,       13 ,        10,   1650,    750,     70,     80,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7418,   0,   0, 1602 }, // TVIN_SIG_FMT_COMPONENT_720P_59D940,
	{1280,     720,    640 ,        10,    20,       13 ,        10,   1980,    750,    400,     80,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_720P_50D000,
	{1920,    1080,      0 ,        10,    20,       14 ,        10,   2750,   1125,    594,     88,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7418,   0,   0, 4004 }, // TVIN_SIG_FMT_COMPONENT_1080P_23D976,
	{1920,    1080,    889 ,        20,    20,       14 ,        10,   2750,   1125,    594,     88,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 4000 }, // TVIN_SIG_FMT_COMPONENT_1080P_24D000,
	{1920,    1080,    853 ,        20,    20,       14 ,        10,   2640,   1125,    484,     88,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 3840 }, // TVIN_SIG_FMT_COMPONENT_1080P_25D000,
	{1920,    1080,    711 ,        10,    20,       14 ,        10,   2200,   1125,     44,     88,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 3200 }, // TVIN_SIG_FMT_COMPONENT_1080P_30D000,//140
	{1920,    1080,    427 ,        10,    20,       7  ,        10,   2640,   1125,    484,     88,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_1080P_50D000,
	{1920,    1080,    356 ,        10,    20,       7  ,        10,   2200,   1125,     44,     88,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1600 }, // TVIN_SIG_FMT_COMPONENT_1080P_60D000,
	{1920,     540,      0 ,        10,    20,       14 ,        10,   2750,    563,    594,     88,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7418,   0,   0, 2002 }, // TVIN_SIG_FMT_COMPONENT_1080I_47D952,
	{1920,     540,      0 ,        10,    20,       14 ,        10,   2750,    563,    594,     88,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7425,   0,   0, 2000 }, // TVIN_SIG_FMT_COMPONENT_1080I_48D000,
	{1920,     540,    853 ,        10,    20,       14 ,        10,   2640,    563,    484,     88,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7425,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_1080I_50D000_A,
	{1920,     540,      0 ,        10,    20,       56 ,        10,   2304,    625,     32,    168,    184,      23,       5,   57,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  7200,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_1080I_50D000_B,
	{1920,     540,      0 ,        10,    20,       21 ,        10,   2376,    625,     81,    132,    243,       4,       1,   80,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7425,   0,   0, 1920 }, // TVIN_SIG_FMT_COMPONENT_1080I_50D000_C,
	{1920,     540,    711 ,        10,    20,       14 ,        10,   2200,    563,     44,     88,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7425,   0,   0, 1600 }, // TVIN_SIG_FMT_COMPONENT_1080I_60D000,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,   0,         TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0, 1600 }, // TVIN_SIG_FMT_COMPONENT_MAX,
};
const struct tvin_format_s tvin_hdmi_fmt_tbl[TVIN_SIG_FMT_HDMI_MAX - TVIN_SIG_FMT_HDMI_640X480P_60HZ + 1] =
{
	//   H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity             Vs_Polarity             Scan_Mode                   Pixel_Clk(Khz/10) VBIs VBIe
	{ 640,     480,       0,        10,    10,         0,        10,    800,    525,     16,     96,     48,      10,       2,   33,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2518,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_640x480P_60Hz,
	{ 720,     480,       0,        10,    10,         0,        10,    858,    525,     16,     62,     60,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2700,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_720x480P_60Hz,
	{1280,     720,       0,        10,    10,         0,        10,   1650,    750,    110,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1280x720P_60Hz,
	{1920,     540,       0,        10,    10,         0,        10,   2200,    563,     88,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7425,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1920x1080I_60Hz,
	{1440,     240,       0,        10,    10,         0,        10,   1716,    263,     38,    124,    114,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  2700,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1440x480I_60Hz,
	{1440,     240,       0,        10,    10,         0,        10,   1716,    262,     38,    124,    114,       4,       3,   15,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2700,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1440x240P_60Hz,
	{2880,     240,       0,        10,    10,         0,        10,   3432,    263,     76,    248,    228,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  5400,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_2880x480I_60Hz,
	{2880,     240,       0,        10,    10,         0,        10,   3432,    262,     76,    248,    228,       4,       3,   15,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 1590 }, // TVIN_SIG_FMT_HDMI_2880x240P_60Hz,
	{1440,     480,       0,        10,    10,         0,        10,   1716,    525,     32,    124,    120,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1440x480P_60Hz,
	{1920,    1080,       0,        10,    10,         0,        10,   2200,   1125,     88,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1920x1080P_60Hz,
	{ 720,     576,       0,        10,    10,         0,        10,    864,    625,     12,     64,     68,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2700,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_720x576P_50Hz, //160
	{1280,     720,       0,        10,    10,         0,        10,   1980,    750,    440,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1280x720P_50Hz,
	{1920,     540,       0,        10,    10,         0,        10,   2640,    563,    528,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED,  7425,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1920x1080I_50Hz_A,
	{1440,     288,       0,        10,    10,         0,        10,   1728,    313,     24,    126,    138,       2,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  2700,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1440x576I_50Hz,
	{1440,     288,       0,        10,    10,         0,        10,   1728,    312,     24,    126,    138,       2,       3,   19,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  2700,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1440x288P_50Hz,
	{2880,     288,       0,        10,    10,         0,        10,   3456,    313,     48,    252,    276,       2,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  5400,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_2880x576I_50Hz,
	{2880,     288,       0,        10,    10,         0,        10,   3456,    312,     48,    252,    276,       2,       3,   19,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_2880x288P_50Hz,
	{1440,     576,       0,        10,    10,         0,        10,   1728,    625,     24,    128,    136,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1440x576P_50Hz,
	{1920,    1080,       0,        10,    10,         0,        10,   2640,   1125,    528,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1920x1080P_50Hz,
	{1920,    1080,       0,        10,    10,         0,        10,   2750,   1125,    638,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 4000 }, // TVIN_SIG_FMT_HDMI_1920x1080P_24Hz,
	{1920,    1080,       0,        10,    10,         0,        10,   2640,   1125,    528,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 3840 }, // TVIN_SIG_FMT_HDMI_1920x1080P_25Hz,//170
	{1920,    1080,       0,        10,    10,         0,        10,   2200,   1125,     88,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 3200 }, // TVIN_SIG_FMT_HDMI_1920x1080P_30Hz,
	{2880,     480,       0,        10,    10,         0,        10,   3432,    525,     64,    248,    240,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_2880x480P_60Hz,
	{2880,     576,       0,        10,    10,         0,        10,   3456,    625,     48,    256,    272,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_2880x576P_60Hz,
	{1920,     540,       0,        10,    10,         0,        10,   2304,    625,     32,    168,    184,      23,       5,   57,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  7200,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1920x1080I_50Hz_B,
	{1920,     540,       0,        10,    10,         0,        10,   2640,    563,    528,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED, 14850,   0,   0, 960  }, // TVIN_SIG_FMT_HDMI_1920x1080I_100Hz,
	{1280,     720,       0,        10,    10,         0,        10,   1980,    750,    440,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 960  }, // TVIN_SIG_FMT_HDMI_1280x720P_100Hz,
	{ 720,     576,       0,        10,    10,         0,        10,    864,    625,     12,     64,     68,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 960  }, // TVIN_SIG_FMT_HDMI_720x576P_100Hz,
	{1440,     288,       0,        10,    10,         0,        10,   1728,    313,     24,     12,    252,       2,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  5400,   0,   0, 960  }, // TVIN_SIG_FMT_HDMI_1440x576I_100Hz,
	{1920,     540,       0,        10,    10,         0,        10,   2200,    563,     88,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED, 14850,   0,   0, 800  }, // TVIN_SIG_FMT_HDMI_1920x1080I_120Hz,
	{1280,     720,       0,        10,    10,         0,        10,   1650,    750,    110,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 800  }, // TVIN_SIG_FMT_HDMI_1280x720P_120Hz,//180
	{ 720,     480,       0,        10,    10,         0,        10,    858,    525,     16,     62,     60,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 800  }, // TVIN_SIG_FMT_HDMI_720x480P_120Hz,
	{1440,     240,       0,        10,    10,         0,        10,   1716,    263,     38,     12,    226,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  5400,   0,   0, 800  }, // TVIN_SIG_FMT_HDMI_1440x480I_120Hz,
	{ 720,     576,       0,        10,    10,         0,        10,    864,    625,     13,     64,     67,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 480  }, // TVIN_SIG_FMT_HDMI_720x576P_200Hz,
	{1440,     288,       0,        10,    10,         0,        10,   1728,    313,     24,     12,    252,       2,       3,   20,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED, 10800,   0,   0, 480  }, // TVIN_SIG_FMT_HDMI_1440x576I_200Hz,
	{ 720,     480,       0,        10,    10,         0,        10,    858,    525,     16,     62,     60,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 10800,   0,   0, 400  }, // TVIN_SIG_FMT_HDMI_720x480P_240Hz,
	{1440,     240,       0,        10,    10,         0,        10,   1716,    263,     38,     12,    226,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED, 10800,   0,   0, 400  }, // TVIN_SIG_FMT_HDMI_1440x480I_240Hz,
	{1280,     720,       0,        10,    10,         0,        10,   3300,    750,   1760,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5940,   0,   0, 4000 }, // TVIN_SIG_FMT_HDMI_1280x720P_24Hz,
	{1280,     720,       0,        10,    10,         0,        10,   3960,    750,   2420,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 3840 }, // TVIN_SIG_FMT_HDMI_1280x720P_25Hz,
	{1280,     720,       0,        10,    10,         0,        10,   3300,    750,   1760,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  7425,   0,   0, 3200 }, // TVIN_SIG_FMT_HDMI_1280x720P_30Hz,
	{1920,    1080,       0,        10,    10,         0,        10,   2200,   1125,     88,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 29700,   0,   0, 800  }, // TVIN_SIG_FMT_HDMI_1920x1080P_120Hz,//190
	{1920,    1080,       0,        10,    10,         0,        10,   2640,   1125,    528,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 29700,   0,   0, 960  }, // TVIN_SIG_FMT_HDMI_1920x1080P_100Hz,
	{1280,    1470,       0,        10,    10,         0,        10,   1650,   1500,    110,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1280x720P_60Hz_FRAME_PACKING,
	{1280,    1470,       0,        10,    10,         0,        10,   1980,   1500,    440,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1280x720P_50Hz_FRAME_PACKING,
	{1280,    1470,       0,        10,    10,         0,        10,   3300,   1500,   1760,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 11880,   0,   0, 4000 }, // TVIN_SIG_FMT_HDMI_1280x720P_24Hz_FRAME_PACKING,
	{1280,    1470,       0,        10,    10,         0,        10,   3300,   1500,   1760,     40,    220,       5,       5,   20,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 3200 }, // TVIN_SIG_FMT_HDMI_1280x720P_30Hz_FRAME_PACKING,
	{1920,    2228,       0,        10,    10,         0,        10,   2200,   2250,     88,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED, 14850,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_1920x1080I_60Hz_FRAME_PACKING,
	{1920,    2228,       0,        10,    10,         0,        10,   2640,   2250,    528,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE,  TVIN_SCAN_MODE_INTERLACED, 14850,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_1920x1080I_50Hz_FRAME_PACKING,
	{1920,    2205,       0,        10,    10,         0,        10,   2750,   2250,    638,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 4000 }, // TVIN_SIG_FMT_HDMI_1920x1080P_24Hz_FRAME_PACKING,
	{1920,    2205,       0,        10,    10,         0,        10,   2200,   2250,     88,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 14850,   0,   0, 3200 }, // TVIN_SIG_FMT_HDMI_1920x1080P_30Hz_FRAME_PACKING,
	//	 H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity			 Vs_Polarity			 Scan_Mode					 Pixel_Clk(Khz/10) VBIs VBIe
	{ 800,     600,       0,        10,    10,         0,        10,   1056,    627,     40,    128,     88,       1,       3,   23,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  4000,   0,   0, 1600 }, // 800x600_60HZ, //200
	//{	0,		 0, 	  0,		 0, 	0,		   0,		  0,	  0,	  0,	  0,	  0,	  0,	   0,		0,	  0,		TVIN_SYNC_POL_NULL, 	TVIN_SYNC_POL_NULL, 	   TVIN_SCAN_MODE_NULL, 	0,	 0,   0,   0  }, // TVIN_SIG_FMT_HDMI_MAX,
	{1024,	   768, 	  0,		10,    10,		   0,		 10,   1344,	806,	 24,	136,	160,	   3,		6,	 29,	TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  6500,	 0,   0, 1600 }, // 1024x768_60HZ,
	{720,     400,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0,   1600}, // TVIN_SIG_FMT_HDMI_720_400,
	{1280,     768,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0,  1600}, // TVIN_SIG_FMT_HDMI_1280_768,
	{1280,     800,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0,  1600}, // TVIN_SIG_FMT_HDMI_1280_800,
	{1280,     960,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0,  1600}, // TVIN_SIG_FMT_HDMI_1280_960,
	{1280,     1024,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_1280_1024,
	{1360,     768,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0,  1600}, // TVIN_SIG_FMT_HDMI_1360_768,
	{1366,     768,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0,  1600}, // TVIN_SIG_FMT_HDMI_1366_768,
	{1600,     1200,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_1600_1200,
	{1920,     1200,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_1920_1200, //210
	{1440,     900,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_1440_900,
	{1400,     1050,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_1400_1050,
	{1680,     1050,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_1680X1050_60HZ
    {1920,     1103,       0,        0,    0,         0,        0,   2200,   2250,     88,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_INTERLACED,  14850,   0,   0, 4000}, // TVIN_SIG_FMT_HDMI_1920X1080I_60HZ_ALTERNATIVE,
    {1920,     1103,       0,        0,    0,         0,        0,   2640,   2250,    528,     44,    148,       2,       5,   16,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_INTERLACED,  14850,   0,   0, 4000}, // TVIN_SIG_FMT_HDMI_1920X1080I_50HZ_ALTERNATIVE,
    {1920,     2160,       0,        0,    0,         0,        0,   2750,   2250,    638,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  14850,   0,   0, 3840}, // TVIN_SIG_FMT_HDMI_1920X1080P_24HZ_ALTERNATIVE,
    {1920,     2160,       0,        0,    0,         0,        0,   2200,   2250,     88,     44,    148,       4,       5,   36,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  14850,   0,   0, 3840}, // TVIN_SIG_FMT_HDMI_1920X1080P_30HZ_ALTERNATIVE,
    {3840,     2160,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  29700,   0,   0, 3200}, // TVIN_SIG_FMT_HDMI_3840_2160_00HZ,
    {4096,     2160,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,  29700,   0,   0, 4000}, // TVIN_SIG_FMT_HDMI_4096_2160_00HZ,
	{0,     0,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_RESERVE7, //220
	{0,     0,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_RESERVE8,
	{0,     0,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_RESERVE9,
	{0,     0,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_RESERVE10,
	{0,     0,       0,        0,    0,         0,        0,   0,    0,     0,    0,    0,       0,       0,   0,    TVIN_SYNC_POL_NULL, TVIN_SYNC_POL_NULL, TVIN_SCAN_MODE_PROGRESSIVE,  0,   0,   0, 1600}, // TVIN_SIG_FMT_HDMI_RESERVE11,
	{ 720,     1005,       0,        10,    10,         0,        10,    858,    1050,     16,     62,     60,       9,       6,   30,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 1600 }, // TVIN_SIG_FMT_HDMI_720x480P_60Hz_FRAME_PACKING,
	{ 720,     1201,       0,        10,    10,         0,        10,    864,    1250,     12,     64,     68,       5,       5,   39,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE,  5400,   0,   0, 1920 }, // TVIN_SIG_FMT_HDMI_720x576P_50Hz_FRAME_PACKING,
	{0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,      0,       0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0,   1600  }, // TVIN_SIG_FMT_HDMI_MAX,//227
};

const struct tvin_format_s tvin_cvbs_fmt_tbl[TVIN_SIG_FMT_CVBS_MAX - TVIN_SIG_FMT_CVBS_NTSC_M + 1] =
{
	//   H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity             Vs_Polarity             Scan_Mode                   Pixel_Clk(Khz/10) VBIs VBIe
	{ 720,     240,       0,         0,     0,         0,         0,    858,    263,     16,     62,     0,        4,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1600 }, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{ 720,     240,       0,         0,     0,         0,         0,    858,    263,     16,     62,     0,        4,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1600 }, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{ 720,     288,       0,         0,     0,         0,         0,    864,    313,     20,     62,     0,        3,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1920 }, // TVIN_SIG_FMT_CVBS_PAL_I,
	{ 720,     240,       0,         0,     0,         0,         0,    858,    263,     20,     62,     0,        4,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1600 }, // TVIN_SIG_FMT_CVBS_PAL_M,
	{ 720,     240,       0,         0,     0,         0,         0,    858,    263,     16,     62,     0,        4,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1600 }, // TVIN_SIG_FMT_CVBS_PAL_60,
	{ 720,     288,       0,         0,     0,         0,         0,    864,    313,     12,     62,     0,        3,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1920 }, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{ 720,     288,       0,         0,     0,         0,         0,    864,    313,     12,     62,     0,        3,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE,  TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1920 }, // TVIN_SIG_FMT_CVBS_SECAM,
	{   0,       0,       0,         0,     0,         0,         0,      0,      0,      0,      0,     0,        0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0,  1600}, // TVIN_SIG_FMT_CVBS_MAX,
};
const struct tvin_format_s tvin_bt601_fmt_tbl[TVIN_SIG_FMT_BT601_MAX - TVIN_SIG_FMT_BT656IN_576I_50HZ + 1] =
{
	//   H_Active V_Active H_cnt Hcnt_offset Vcnt_offset Hs_cnt Hscnt_offset H_Total V_Total Hs_Front Hs_Width Hs_bp Vs_Front Vs_Width Vs_bp Hs_Polarity             Vs_Polarity             Scan_Mode                   Pixel_Clk(Khz/10) VBIs VBIe
	{ 720,     288,    6400,        20,    10,         0,         10,    864,    625,     12,     64,     0,        5,       5,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1920 }, // TVIN_SIG_FMT_BT656IN_576I,
	{ 720,     240,    6356,        20,    10,         0,         10,    858,    525,     16,     62,     0,        9,       6,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1600 }, // TVIN_SIG_FMT_BT656IN_480I, // 160
	{ 720,     288,    6400,        20,    10,         0,         10,    864,    625,     12,     64,     0,        5,       5,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1920 }, // TVIN_SIG_FMT_BT601IN_576I,
	{ 720,     240,    6356,        20,    10,         0,         10,    858,    525,     16,     62,     0,        9,       6,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_INTERLACED,  1350,   0,   0, 1600 }, // TVIN_SIG_FMT_BT601IN_480I,
	{ 640,     480,    6356,        20,    10,       473,         10,    780,    525,     18,     58,     64,       4,       3,   16,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 1227,   0,   0, 3200 }, // TVIN_SIG_FMT_CAMERA_640X480P_30HZ,
	{ 800,     600,       0,        20,    10,         0,         10,   1056,    628,     40,    128,     0,        1,       4,    0,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE, 4000,   0,   0, 3200 }, // TVIN_SIG_FMT_CAMERA_800X600P_30HZ,
	{1024,     768,       0,        10,    10,         0,         10,   1344,    795,     64,    128,     0,        3,       3,    0,    TVIN_SYNC_POL_NEGATIVE, TVIN_SYNC_POL_NEGATIVE, TVIN_SCAN_MODE_PROGRESSIVE, 6411,   0,   0, 3200 }, // TVIN_SIG_FMT_CAMERA_1024X768P_30HZ,
	{1920,    1080,       0,        10,    10,         0,         10,   2576,   1118,    120,    208,     0,        1,       3,    0,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,17280,   0,   0, 3200 }, // TVIN_SIG_FMT_CAMERA_1920X1080P_30HZ,
	{1280,    720,        0,        10,    10,         0,         10,   1650,    750,    120,    208,     0,        1,       3,    0,    TVIN_SYNC_POL_POSITIVE, TVIN_SYNC_POL_POSITIVE, TVIN_SCAN_MODE_PROGRESSIVE,17280,   0,   0, 3200 }, // TVIN_SIG_FMT_CAMERA_1280X720P_30HZ,
	//format max
	{   0,       0,       0,         0,     0,         0,          0,      0,      0,      0,      0,     0,        0,       0,    0,        TVIN_SYNC_POL_NULL,     TVIN_SYNC_POL_NULL,        TVIN_SCAN_MODE_NULL,     0,   0,   0,     1600},  //TVIN_SIG_FMT_MAX,        // 160
};


#define r_0a 0x00
#define r_0e 0x00
#define r_12 0x00
#define r_16 0x00
#define r_1c 0x00
#define r_1d 0x00
#define r_22 0x00
#define r_23 0x00
#define r_25 0x00
#define r_29 0x00
#define r_2c 0x00
#define r_2d 0x00
#define r_36 0x00
#define r_37 0x00
#define r_40 0x00
#define r_42 0x00
#define r_44 0x00
#define r_45 0x00
#define r_48 0x00
#define r_49 0x00
#define r_4a 0x00
#define r_4b 0x00
#define r_4c 0x00
#define r_4d 0x00
#define r_4e 0x00
#define r_4f 0x00
#define r_50 0x00
#define r_51 0x00
#define r_52 0x00
#define r_53 0x00
#define r_54 0x00
#define r_55 0x00
#define r_57 0x00
#define r_67 0x00
#define r_6a 0x00
#define r_6b 0x00
#define r_6c 0x00
#define r_6d 0x00
#define r_6e 0x00
#define r_6f 0x00

const unsigned char adc_vga_table[TVIN_SIG_FMT_VGA_MAX - TVIN_SIG_FMT_VGA_512X384P_60HZ_D147][ADC_REG_NUM] =
{
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_512X384P_60D147,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_560X384P_60D147,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X200P_59D924,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X350P_85D080,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X400P_59D940,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22,0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X400P_85D080,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X400P_59D638,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X400P_56D416,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X480P_66D619,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X480P_66D667,   // 10
	{
		0x32, 0x31, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x11, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0xBF, 0x28, 0x02,
		0xF4, 0x00, 0x28, 0x39, 0x00, 0x00, 0x10, 0x00, 0x24, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

	}, // TVIN_SIG_FMT_VGA_640X480P_59D940,
	{
		0x32, 0x31, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x11, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0xBF, 0x28, 0x02,
		0xF4, 0x00, 0x28, 0x39, 0x00, 0x00, 0x10, 0x00, 0x24, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_VGA_640X480P_60D000,
	{
		0x32, 0x33, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x98, 0x90, 0x99, 0x80, 0x11, 0x12, 0x10, 0x10, 0x40,
		0x4F, 0x45, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x20, 0x22, 0x8f, 0x6F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x21, 0x00, 0x00, 0x10, 0x00, 0x30, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_640X480P_72D809,
	{
		0x32, 0x34, 0x70, 0x08, 0x14, 0x12, 0x00, 0x98, 0x90, 0x99, 0x80, 0x11, 0x12, 0x10, 0x10, 0x40,
		0x4F, 0x45, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x20, 0x22, 0x8f, 0x6F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x21, 0x00, 0x00, 0x10, 0x00, 0x30, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_640X480P_75D000_A,
	{
		0x32, 0x34, 0x70, 0x08, 0x14, 0x12, 0x00, 0x98, 0x90, 0x99, 0x80, 0x11, 0x12, 0x10, 0x10, 0x40,
		0x4F, 0x45, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x20, 0x22, 0x8f, 0x6F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x30, 0x74, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_640X480P_85D008,
	{
		0x32, 0x31, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x98, 0x90, 0x99, 0x80, 0x11, 0x12, 0x10, 0x10, 0x40,
		0x4F, 0x45, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,         //why is no lpf open
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x20, 0x22, 0x8f, 0x6F, 0x28, 0x00,  //for dpll lock make 0x59 = 0x06->0x08
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x20, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_640X480P_59D638,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X480P_75D000_B,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_640X870P_75D000,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_720X350P_70D086,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_720X400P_85D039,  // 20
	{
		0x32, 0x38, 0x30, 0x08, 0x14, 0x12, 0x00, 0x98, 0x90, 0x99, 0x80, 0x11, 0x12, 0x10, 0x10, 0x40,
		0x4F, 0x45, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x10, 0x10, 0x10, 0x30, 0x00, 0x29, 0x88,         //why is no lpf open
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x10, 0x00, 0x00, 0x08, 0x20, 0x22, 0x8f, 0x6F, 0x28, 0x00,  //for dpll lock make 0x59 = 0x06->0x08
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x20, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_720X400P_70D086,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x20, 0x20, 0x20, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_720X400P_87D849,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_720X400P_59D940,
	{
		0x32, 0x35, 0x90, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x10, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x20, 0x20, 0x20, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,
		0xF4, 0x00, 0x28, 0x29, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_VGA_720X480P_59D940,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x10, 0x10, 0x10, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_768X480P_59D896,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x20, 0x20, 0x20, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_800X600P_56D250,
	{
		0x32, 0x3f, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x10, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x20, 0x20, 0x20, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,
		0xF4, 0x00, 0x28, 0x29, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_VGA_800X600P_60D000,
	{
		0x32, 0x41, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x10, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x20, 0x20, 0x20, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,
		0xF4, 0x00, 0x28, 0x29, 0x00, 0x00, 0x10, 0x00, 0x25, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_VGA_800X600P_60D000_A,
	{
		0x32, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x10, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x20, 0x20, 0x20, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,
		0xF4, 0x00, 0x28, 0x29, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_VGA_800X600P_60D317,
	{
		0x32, 0x40, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x9F, 0xB0, 0xAF, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x47,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x0a, 0x26, 0x22, 0x8f, 0x6F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x21, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_800X600P_72D188, //30
	{
		0x32, 0x41, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x9F, 0xB0, 0xAF, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x47,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x0a, 0x24, 0x22, 0x8f, 0x6F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x21, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_800X600P_75D000,
	{
		0x32, 0x41, 0x70, 0x08, 0x14, 0x12, 0x00, 0x9F, 0xB0, 0xAF, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x47,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x07, 0x24, 0x22, 0x8f, 0x6F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x21, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_800X600P_85D061,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x30, 0x30, 0x30, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_832X624P_75D087,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x30, 0x30, 0x30, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_848X480P_84D751,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x30, 0x30, 0x30, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_960X600P_59D635,
	{
		0x32, 0x53, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x05, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_59D278,
	{
		0x32, 0x53, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x05, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_60D000,
	{
		0x32, 0x52, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x05, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_60D000_A,
	{
		0x32, 0x52, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x05, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x12, 0x00, 0x00, 0x10, 0x00, 0x26, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_60D000_B,
	{
		0x32, 0x52, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_74D927,  //40
	{
		0x32, 0x53, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_60D004,
	{
		0x32, 0x52, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_70D069,
	{
		0x32, 0x51, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_75D029,
	{
		0x32, 0x55, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x20, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_84D997,
	{
		0x32, 0x53, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_74D925,
	{
		0x32, 0x52, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x05, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_VGA_1024X768P_60D020,
	{
		0x32, 0x53, 0x00, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_70D008,
	{
		0x32, 0x57, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_75D782,
	{
		0x32, 0x54, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_77D069,
	{
		0x32, 0x50, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_71D799, //50
	{
		0x32, 0x57, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X1024P_60D000,
	{
		0x32, 0x5e, 0xf0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1152X864P_60D000,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X864P_70D012,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X864P_75D000,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X864P_84D999,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X870P_75D062,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X900P_65D950,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X900P_66D004,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X900P_76D047,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1152X900P_76D149, //60
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X720P_59D855,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X720P_60D000_A,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X720P_60D000_B,
	{
		0x32, 0x67, 0x10, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x07, 0x25, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X720P_60D000_C,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X720P_60D000_D,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x05, 0x0a, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X768P_59D870,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X768P_59D995,
	{
		0x32, 0x68, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X768P_60D100,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X768P_60D100_A,
	{
		0x32, 0x69, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x59, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X768P_74D893, //70
	{
		0x32, 0x6a, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x23, 0x59, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X768P_84D837,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X800P_59D810,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X800P_59D810_A,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x25, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X800P_60D000,
	{
		0x32, 0x6a, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x03, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x0a, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x25, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X800P_85D000,
	{
		0x32, 0x67, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x25, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X960P_60D000,
	{
		0x32, 0x6A, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x25, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X960P_60D000_A,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X960P_75D000,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X960P_85D002,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X1024P_60D020,  //80
	{
		0x32, 0x69, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x09, 0x25, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X1024P_60D020_A,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X1024P_75D025,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x23, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1280X1024P_85D024,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_59D979,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_72D005,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_60D002,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_67D003,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_74D112,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_76D179,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_66D718, //90
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_66D677,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x70, 0x70, 0x70, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1280X1024P_76D107,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,   //why the lpfbwctr 1280x1024 < 1024x768
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, //TVIN_SIG_FMT_VGA_1280X1024P_59D996,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,   //why the lpfbwctr 1280x1024 < 1024x768
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, //TVIN_SIG_FMT_VGA_1280X1024P_60D000,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,   //why the lpfbwctr 1280x1024 < 1024x768
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1360X768P_59D799,
	{
		0x32, 0x6f, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1360X768P_60D015,
	{
		0x32, 0x6f, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x12, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1360X768P_60D015_A,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,   //why the lpfbwctr 1280x1024 < 1024x768
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1360X850P_60D000,
	{
		0x32, 0x69, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,   //why the lpfbwctr 1280x1024 < 1024x768
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1360X1024P_60D000,
	{
		0x32, 0x6f, 0xd0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1366X768P_59D790,  //100
	{
		0x32, 0x5d, 0xb0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x22, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1366X768P_60D000,
	{
		0x32, 0x75, 0x50, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1400X1050P_59D978,
	{
		0x32, 0x76, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1440X900P_59D887,
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x40, 0x40, 0x40, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1440X1080P_60D000,
	{
		0x32, 0x86, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1600X900P_60D000,
	{
		0x32, 0x86, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1600X1024P_60D000,
	{
		0x32, 0x86, 0x50, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1600X1200P_59D869,
	{
		0x32, 0x86, 0xf0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1600X1200P_60D000,
	{
		0x32, 0x85, 0x80, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01 ,0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x26, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x23, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1600X1200P_65D000,
	{
		0x32, 0x86, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x0A, 0x26, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x23, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1600X1200P_70D000,
	{
		0x32, 0x8b, 0xf0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1680X1050P_59D954, //110
	{
		0x00, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x40, 0x40, r_12, 0x23, 0x23, 0x63, r_16, 0x00, 0x00, 0x70, 0x70, 0x70, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x46, 0x28,
		0x20, 0x20, 0x0c, 0x0f, 0x25, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5c, 0x54, 0x81, 0x08, 0x08,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x22, 0x22, 0x5f, 0x6f, 0x04, 0x04,
		0xf4, 0x00, 0x05, 0x29, 0x00, 0x00, 0x10, r_67, 0x2d, 0x39, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f,
	}, // TVIN_SIG_FMT_VGA_1680X1080P_60D000,
	{
		0x32, 0x9e, 0xe0, 0x08, 0x14, 0x12, 0x00, 0x95, 0xA9, 0xA9, 0x80, 0x12, 0x11, 0x14, 0x10, 0x4F,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,     //1b why = 70 ?what is the diff
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x97, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x00, 0x00, 0x14, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0xAF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x00, 0x00, 0x00, 0x10, 0x00, 0x23, 0xE1, 0x05, 0x05, 0x05, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1920X1080P_49D929
	{
		0x32, 0xA0, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x95, 0xA9, 0xA9, 0x80, 0x12, 0x11, 0x14, 0x10, 0x4F,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,     //1b why = 70 ?what is the diff
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x97, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x00, 0x00, 0x14, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0xAF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x00, 0x00, 0x00, 0x10, 0x00, 0x23, 0xE1, 0x05, 0x05, 0x05, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1920X1080P_59D963_A,
	{
		0x32, 0xA0, 0xd0, 0x08, 0x14, 0x12, 0x00, 0x95, 0xA9, 0xA9, 0x80, 0x12, 0x11, 0x14, 0x10, 0x4F,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,     //1b why = 70 ?what is the diff
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x97, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x00, 0x00, 0x14, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0xAF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x00, 0x00, 0x00, 0x10, 0x00, 0x23, 0xE1, 0x05, 0x05, 0x05, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1920X1080P_59D963,
	{
		0x32, 0x89, 0x70, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x00, 0x10, 0x10, 0x10, 0x00, 0x40, //VGA_1920_1080P_IN
		0x40, 0x40, 0x00, 0x23, 0x23, 0x63, 0x00, 0x33, 0x30, 0x70, 0x70, 0x70, 0x00, 0x00, 0x29, 0x88,
		0x00, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x56, 0x28,
		0x02, 0x20, 0x03, 0x03, 0xB7, 0x02, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x59, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x20, 0x00, 0x00,
		0x13, 0x10, 0x02, 0x01, 0x00, 0x00, 0x1A, 0x00, 0x00, 0x08, 0x27, 0x22, 0x8f, 0x0F, 0x04, 0x3f,
		0xF4, 0x00, 0x05, 0x09, 0x00, 0x00, 0x10, 0x00, 0x23, 0x59, 0x05, 0x05, 0x00, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_VGA_1920X1080P_60D000,
	{
		0x32, 0x81, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x95, 0xA9, 0xA9, 0x80, 0x12, 0x11, 0x14, 0x10, 0x4F,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,     //1b why = 70 ?what is the diff
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x97, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x00, 0x00, 0x04, 0x00, 0x00, 0x0A, 0x26, 0x22, 0x8f, 0xAF, 0x28, 0x08,
		0xFF, 0x00, 0x28, 0x02, 0x00, 0x00, 0x10, 0x00, 0x23, 0xE1, 0x05, 0x05, 0x05, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1920X1200P_59D950,  // 113
	{
		0x32, 0x54, 0x50, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x00,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_60D000_C,
	{
		0x32, 0x52, 0xF0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB3, 0xB1, 0x80, 0x11, 0x0E, 0x12, 0x10, 0x48,
		0x49, 0x4B, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x92, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x08,    ///what 54 mean
		0xFF, 0x00, 0x28, 0x12, 0x00, 0x00, 0x10, 0x00, 0x26, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1024X768P_60D000_D,
	{
		0x32, 0xA1, 0xF0, 0x08, 0x14, 0x12, 0x00, 0x95, 0xA9, 0xA9, 0x80, 0x12, 0x11, 0x14, 0x10, 0x4F,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,     //1b why = 70 ?what is the diff
		0x10, 0x05, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0x97, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x00, 0x00, 0x04, 0x00, 0x00, 0x0A, 0x26, 0x22, 0x8f, 0xAF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x02, 0x00, 0x00, 0x10, 0x00, 0x23, 0xE1, 0x05, 0x05, 0x05, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1920X1200P_59D988,
		{
		0x32, 0x63, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0xAC, 0xAD, 0x80, 0x12, 0x0F, 0x13, 0x10, 0x46,
		0x47, 0x48, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x40, 0x40, 0x40, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x18, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, //TVIN_SIG_FMT_VGA_1400X900P_60D00,
		{
		0x32, 0x72, 0xf0, 0x08, 0x14, 0x12, 0x00, 0xA0, 0xB2, 0xB1, 0x80, 0x13, 0x12, 0x14, 0x10, 0x42,
		0x46, 0x47, 0x40, 0x23, 0x23, 0x63, 0x23, 0x33, 0x30, 0x70, 0x70, 0x70, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x01, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x32, 0x00, 0x0D, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0xBF, 0x28, 0x3f,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x23, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_VGA_1680X1050P_60D000,
	{
		0x32, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x10, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x20, 0x20, 0x20, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x76, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,
		0xF4, 0x00, 0x28, 0x29, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
	},  // TVIN_SIG_FMT_VGA_800X600P_60D062,
	{
		0x32, 0x41, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x99, 0x99, 0x99, 0x80, 0x10, 0x10, 0x10, 0x10, 0x40,
		0x40, 0x40, 0x40, 0x23, 0x23, 0x23, 0x23, 0x33, 0x30, 0x20, 0x20, 0x20, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x07, 0xC0, 0x00, 0x03, 0x00, 0x78, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x56, 0x28,
		0x20, 0x20, 0x08, 0x15, 0xB7, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5F, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x03, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x27, 0x00, 0x13, 0x00, 0x00, 0x08, 0x26, 0x22, 0x8f, 0x8F, 0x28, 0x03,
		0xF4, 0x00, 0x28, 0x29, 0x00, 0x00, 0x10, 0x00, 0x21, 0x29, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00,
	},//TVIN_SIG_FMT_VGA_800X600P_60D317_B
};

const unsigned char adc_component_table[TVIN_SIG_FMT_COMP_MAX - TVIN_SIG_FMT_COMP_480P_60HZ_D000][ADC_REG_NUM] =
{
#ifdef CONFIG_ADC_DOUBLE_SAMPLING_FOR_SD
	{
		0x32, 0x6b, 0x30, 0x08, 0x14, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x83, 0x83, 0x83, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x30, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x13, 0x00, 0x00, 0x04, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x25, 0x99, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_COMPONENT_480P_60D000,zhuangwei
	{
		0x32, 0x6b, 0x30, 0x40, 0x25, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x81, 0x81, 0x81, 0x30, 0x00, 0x29, 0x88,    ///why the lpfbwctr 480i == 480p = 28?
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x4B, 0x78, 0x00, 0x0D, 0x02, 0x01, 0xFF, 0x00, 0x7F, 0x28,
		0x17, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x84, 0xE3, 0x14, 0x14,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x18, 0x00, 0x00, 0x04, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x21, 0x00, 0x00, 0x10, 0x00, 0x24, 0x99, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_480I_59D940,wangfeng
	{
		0x32, 0x6b, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x83, 0x83, 0x83, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x30, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00,  0xa, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x25, 0x99, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_576P_50D000,wan gfeng
	{
		0x32, 0x6b, 0xf0, 0x40, 0x25, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x81, 0x81, 0x81, 0x30, 0x00, 0x29, 0x88,    ///why the lpfbwctr 480i == 480p = 28?
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x4B, 0x78, 0x01, 0x0D, 0x02, 0x01, 0xFF, 0x00, 0x7F, 0x28,
		0x30, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x84, 0xe3, 0x14, 0x14,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x18, 0x00, 0x00, 0x04, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x24, 0xa9, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_576I_50D000,wangfeng
#else
	{
		0x32, 0x35, 0x90, 0x08, 0x14, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x83, 0x83, 0x83, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x30, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x13, 0x00, 0x00, 0x0a, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x25, 0x99, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_COMPONENT_480P_60D000,zhuangwei
	{
		0x32, 0x35, 0x90, 0x20, 0x14, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x81, 0x81, 0x81, 0x30, 0x00, 0x29, 0x88,    ///why the lpfbwctr 480i == 480p = 28?
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x30, 0x78, 0x00, 0x0D, 0x00, 0x01, 0xFF, 0x00, 0x7F, 0x28,
		0x17, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x84, 0xE3, 0x14, 0x14,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00, 0x0f, 0x00, 0x00, 0x06, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x24, 0x99, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_480I_59D940,wangfeng
	{
		0x32, 0x35, 0xf0, 0x08, 0x14, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x83, 0x83, 0x83, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x00, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x30, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x01, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00,  0xa, 0x00, 0x00, 0x08, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x25, 0x99, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_576P_50D000,wan gfeng
	{
		0x32, 0x35, 0xf0, 0x20, 0x14, 0x12, 0x00, 0x98, 0x91, 0x9A, 0x80, 0x11, 0x11, 0x10, 0x10, 0x40,
		0x87, 0x88, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x81, 0x81, 0x81, 0x30, 0x00, 0x29, 0x88,    ///why the lpfbwctr 480i == 480p = 28?
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x0f, 0x0D, 0x00, 0x01, 0xFF, 0x00, 0x7F, 0x28,
		0x30, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x84, 0xe3, 0x14, 0x14,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x10, 0x00,  0xa, 0x00, 0x00, 0x06, 0x24, 0x22, 0x8f, 0x8F, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x31, 0x00, 0x00, 0x10, 0x00, 0x24, 0xa9, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_576I_50D000,wangfeng
#endif
	{
		0x32, 0x67, 0x10, 0x40, 0x14, 0x12, 0x00, 0x98, 0x92, 0x9A, 0x80, 0x12, 0x11, 0x10, 0x10, 0x42,
		0x8D, 0x8E, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x0f, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x20, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x04, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x22, 0x00, 0x07, 0x00, 0x00, 0x05, 0x26, 0x02, 0x8f, 0xAF, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x15, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_COMPONENT_720P_59D940,zhuangwei
	{
		0x32, 0x7b, 0xb0, 0x40, 0x14, 0x12, 0x00, 0x98, 0x92, 0x9A, 0x80, 0x12, 0x11, 0x10, 0x10, 0x42,
		0x8D, 0x8E, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,    //why no open lpf
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x0f, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x20, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x22, 0x00, 0x08, 0x00, 0x00, 0x08, 0x26, 0x02, 0x8f, 0xAF, 0x28, 0x00,     //0x59 0x08->0x09 ;0x60 0x00->0x04
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x15, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_720P_50D000,wangfeng
	{
		0x00, 0x35, 0xf0, 0x14, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x80, 0x80, r_12, 0x23, 0x23, 0x23, r_16, 0x00, 0x00, 0xda, 0xda, 0xda, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x64, 0x28,
		0x20, 0x32, 0x08, 0x0f, 0x6f, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5D, 0x54, 0x81, 0x04, 0x02,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x23, 0x22, 0x8f, 0x6f, 0x0e, 0x02,
		0xf4, 0x00, 0x0e, 0x39, 0x00, 0x00, 0x10, r_67, 0x2c, 0x29, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f
	}, // TVIN_SIG_FMT_COMPONENT_1080P_23D976,
	{
		0x32, 0xab, 0xd0, 0x40, 0x14, 0x12, 0x00, 0x98, 0x92, 0x9A, 0x80, 0x12, 0x11, 0x10, 0x10, 0x42,
		0x8D, 0x8E, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,    //why no open lpf
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x02, 0x00, 0x04, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x20, 0x51, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5A, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x22, 0x00, 0x19, 0x00, 0x00, 0x08, 0x24, 0x02, 0x8f, 0xAF, 0x28, 0x00, 	//0x59 0x08->0x09 ;0x60 0x00->0x04
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x15, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_1080P_24D000,
	{
		0x32, 0xa4, 0xf0, 0x40, 0x14, 0x12, 0x00, 0x98, 0x92, 0x9A, 0x80, 0x12, 0x11, 0x10, 0x10, 0x42,
		0x8D, 0x8E, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,    //why no open lpf
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x02, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x20, 0x4d, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0xE3, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x22, 0x00, 0x1e, 0x00, 0x00, 0x08, 0x24, 0x02, 0x8f, 0xAF, 0x28, 0x00, 	//0x59 0x08->0x09 ;0x60 0x00->0x04
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x15, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_1080P_25D000,
	{
		0x32, 0x89, 0x70, 0x40, 0x14, 0x12, 0x00, 0x98, 0x92, 0x9A, 0x80, 0x12, 0x11, 0x10, 0x10, 0x42,
		0x8D, 0x8E, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x40, 0x78, 0x0f, 0x00, 0x00, 0x01, 0xFF, 0x00, 0x5F, 0x28,
		0x20, 0x32, 0x03, 0x03, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x04, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x22, 0x00, 0x12, 0x00, 0x00, 0x05, 0x24, 0x02, 0x8f, 0xAF, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x26, 0x15, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_1080P_30D000,
	{
		0x32, 0xa4, 0xf0, 0x40, 0x40, 0x12, 0x00, 0x93, 0x8D, 0x94, 0x80, 0x13, 0x12, 0x11, 0x10, 0x41,
		0x87, 0x87, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x8f, 0x8f, 0x8f, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x79, 0x78, 0x02, 0x0d, 0x02, 0x01, 0xFF, 0x00, 0x5f, 0x28,
		0x20, 0x32, 0x02, 0x02, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x31, 0x00, 0x1d, 0x00, 0x00, 0x08, 0x24, 0x02, 0x8f, 0xAF, 0x28, 0x00,    ////dpll
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x27, 0x65, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_COMPONENT_1080P_50D000,zhuangwei wangfeng
	{
		0x32, 0x89, 0x70, 0x40, 0x40, 0x12, 0x00, 0x93, 0x8D, 0x94, 0x80, 0x13, 0x12, 0x11, 0x10, 0x41,
		0x87, 0x87, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x8f, 0x8f, 0x8f, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x79, 0x78, 0x00, 0x0d, 0x02, 0x01, 0xFF, 0x00, 0x5f, 0x28,
		0x20, 0x32, 0x02, 0x02, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x31, 0x00, 0x0a, 0x00, 0x00, 0x07, 0x27, 0x02, 0x8f, 0xAF, 0x28, 0x00,
		0xFF, 0x00, 0x28, 0x01, 0x00, 0x00, 0x10, 0x00, 0x27, 0x65, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_COMPONENT_1080P_60D000,
	{
		0x00, 0x35, 0xf0, 0x14, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x80, 0x80, r_12, 0x23, 0x23, 0x23, r_16, 0x00, 0x00, 0xda, 0xda, 0xda, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x64, 0x28,
		0x20, 0x32, 0x08, 0x0f, 0x6f, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5D, 0x54, 0x81, 0x04, 0x02,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x23, 0x22, 0x8f, 0x6f, 0x0e, 0x02,
		0xf4, 0x00, 0x0e, 0x39, 0x00, 0x00, 0x10, r_67, 0x2c, 0x29, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f
	}, // TVIN_SIG_FMT_COMPONENT_1080I_47D952,
	{
		0x00, 0x35, 0xf0, 0x14, 0x14, 0x12, 0x00, 0x00, 0x00, 0x00, r_0a, 0x10, 0x10, 0x10, r_0e, 0x40,
		0x80, 0x80, r_12, 0x23, 0x23, 0x23, r_16, 0x00, 0x00, 0xda, 0xda, 0xda, r_1c, r_1d, 0x69, 0x88,
		0x10, 0x03, r_22, r_23, 0x00, r_25, 0x78, 0x78, 0x00, r_29, 0x00, 0x00, r_2c, r_2d, 0x64, 0x28,
		0x20, 0x32, 0x08, 0x0f, 0x6f, 0x02, r_36, r_37, 0x20, 0xc0, 0x03, 0x5D, 0x54, 0x81, 0x04, 0x02,
		r_40, 0x07, r_42, 0xf0, r_44, r_45, 0x51, 0x5a, r_48, r_49, r_4a, r_4b, r_4c, r_4d, r_4e, r_4f,
		r_50, r_51, r_52, r_53, r_54, r_55, 0x10, r_57, 0x00, 0x06, 0x23, 0x22, 0x8f, 0x6f, 0x0e, 0x02,
		0xf4, 0x00, 0x0e, 0x39, 0x00, 0x00, 0x10, r_67, 0x2c, 0x29, r_6a, r_6b, r_6c, r_6d, r_6e, r_6f
	}, // TVIN_SIG_FMT_COMPONENT_1080I_48D000,

	{
		0x32, 0xa4, 0xf0, 0x40, 0x40, 0x12, 0x00, 0x93, 0x8D, 0x94, 0x80, 0x13, 0x12, 0x11, 0x10, 0x41,
		0x87, 0x87, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x60, 0x78, 0x0f, 0x00, 0x02, 0x01, 0xFF, 0x00, 0x5f, 0x28,
		0x20, 0x3f, 0x02, 0x02, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x31, 0x00,  0x5, 0x00, 0x00, 0x05, 0x26, 0x02, 0x8f, 0xAF, 0x28, 0x00,    ////dpll
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x65, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_1080I_50D000_A,

	{
		0x32, 0xa4, 0xf0, 0x40, 0x40, 0x12, 0x00, 0x93, 0x8D, 0x94, 0x80, 0x13, 0x12, 0x11, 0x10, 0x41,
		0x87, 0x87, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x60, 0x78, 0x02, 0x00, 0x02, 0x01, 0xFF, 0x00, 0x5f, 0x28,
		0x20, 0x32, 0x02, 0x02, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x31, 0x00,  0x5, 0x00, 0x00, 0x08, 0x26, 0x02, 0x8f, 0xAF, 0x28, 0x00,    ////dpll
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x65, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_1080I_50D000_B,
	{
		0x32, 0xa4, 0xf0, 0x40, 0x40, 0x12, 0x00, 0x93, 0x8D, 0x94, 0x80, 0x13, 0x12, 0x11, 0x10, 0x41,
		0x87, 0x87, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x60, 0x78, 0x02, 0x00, 0x02, 0x01, 0xFF, 0x00, 0x5f, 0x28,
		0x20, 0x32, 0x02, 0x02, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x31, 0x00, 0x10, 0x00, 0x00, 0x08, 0x26, 0x02, 0x8f, 0xAF, 0x28, 0x00,    ////dpll
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x65, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	}, // TVIN_SIG_FMT_COMPONENT_1080I_50D000_C,

	{
		0x32, 0x89, 0x70, 0x40, 0x40, 0x12, 0x00, 0x93, 0x8D, 0x94, 0x80, 0x13, 0x12, 0x11, 0x10, 0x41,
		0x87, 0x87, 0x40, 0x23, 0x23, 0x63, 0x23, 0x11, 0x10, 0x88, 0x88, 0x88, 0x30, 0x00, 0x29, 0x88,
		0x10, 0x05, 0xC0, 0x00, 0x01, 0x00, 0x60, 0x78, 0x0c, 0x00, 0x02, 0x01, 0xFF, 0x00, 0x5f, 0x28,
		0x20, 0x32, 0x02, 0x02, 0x6B, 0x07, 0x10, 0x00, 0x00, 0xC0, 0xE3, 0x5D, 0x54, 0x63, 0x08, 0x08,
		0x70, 0x07, 0x75, 0xF0, 0xF0, 0xF0, 0x5D, 0x5A, 0x00, 0x00, 0x85, 0x09, 0x00, 0x29, 0x00, 0x00,
		0x1D, 0x28, 0x02, 0x01, 0x31, 0x00, 0x10, 0x00, 0x00, 0x08, 0x26, 0x02, 0x8f, 0xAF, 0x28, 0x00,    ////dpll
		0xFF, 0x00, 0x28, 0x11, 0x00, 0x00, 0x10, 0x00, 0x27, 0x65, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00
	},// TVIN_SIG_FMT_COMPONENT_1080I_60D000,
};

const unsigned char adc_cvbs_table[ADC_REG_NUM] =
{
	/*0x40*/
	0x00, 0x6b, 0xf0, 0x08, 0x14, 0x30, 0x10, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x10, 0x00, 0x00,
	0x00, 0x00, 0x40, 0x23, 0x03, 0x83, 0x22, 0x10, 0x00, 0x80, 0x30, 0x00, 0x00, 0x00, 0x69, 0x88,
	0x30, 0x07, 0xc0, 0x00, 0x05, 0x00, 0x3f, 0x3f, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x40, 0x28,
	0x20, 0x20, 0x08, 0x0f, 0x25, 0x02, 0x10, 0x00, 0x00, 0xc0, 0xe3, 0x5c, 0x54, 0x81, 0x01, 0x08,
	0x70, 0x07, 0x75, 0xf8, 0xf0, 0xf0, 0x51, 0x5a, 0x00, 0x00, 0x85, 0x01, 0x00, 0x30, 0x00, 0x00,
	0x18, 0x15, 0x03, 0x00, 0xe0, 0x00, 0x10, 0x00, 0x09, 0x07, 0x02, 0x22, 0x8e, 0x6f, 0x0f, 0x09,
	0xf4, 0x00, 0x0f, 0x19, 0x00, 0x00, 0x10, 0x00, 0x0b, 0x39, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

#define r180 (unsigned char)((CVD2_CHROMA_DTO_NTSC_M  >>24)&0x000000ff)
#define r190 (unsigned char)((CVD2_CHROMA_DTO_NTSC_M  >>16)&0x000000ff)
#define r1a0 (unsigned char)((CVD2_CHROMA_DTO_NTSC_M  >> 8)&0x000000ff)
#define r1b0 (unsigned char)((CVD2_CHROMA_DTO_NTSC_M  >> 0)&0x000000ff)
#define r1c0 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_M  >>24)&0x000000ff)
#define r1d0 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_M  >>16)&0x000000ff)
#define r1e0 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_M  >> 8)&0x000000ff)
#define r1f0 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_M  >> 0)&0x000000ff)

#define r181 (unsigned char)((CVD2_CHROMA_DTO_NTSC_443>>24)&0x000000ff)
#define r191 (unsigned char)((CVD2_CHROMA_DTO_NTSC_443>>16)&0x000000ff)
#define r1a1 (unsigned char)((CVD2_CHROMA_DTO_NTSC_443>> 8)&0x000000ff)
#define r1b1 (unsigned char)((CVD2_CHROMA_DTO_NTSC_443>> 0)&0x000000ff)
#define r1c1 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_443>>24)&0x000000ff)
#define r1d1 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_443>>16)&0x000000ff)
#define r1e1 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_443>> 8)&0x000000ff)
#define r1f1 (unsigned char)(( CVD2_HSYNC_DTO_NTSC_443>> 0)&0x000000ff)

#define r182 (unsigned char)((CVD2_CHROMA_DTO_PAL_I   >>24)&0x000000ff)
#define r192 (unsigned char)((CVD2_CHROMA_DTO_PAL_I   >>16)&0x000000ff)
#define r1a2 (unsigned char)((CVD2_CHROMA_DTO_PAL_I   >> 8)&0x000000ff)
#define r1b2 (unsigned char)((CVD2_CHROMA_DTO_PAL_I   >> 0)&0x000000ff)
#define r1c2 (unsigned char)(( CVD2_HSYNC_DTO_PAL_I   >>24)&0x000000ff)
#define r1d2 (unsigned char)(( CVD2_HSYNC_DTO_PAL_I   >>16)&0x000000ff)
#define r1e2 (unsigned char)(( CVD2_HSYNC_DTO_PAL_I   >> 8)&0x000000ff)
#define r1f2 (unsigned char)(( CVD2_HSYNC_DTO_PAL_I   >> 0)&0x000000ff)

#define r183 (unsigned char)((CVD2_CHROMA_DTO_PAL_M   >>24)&0x000000ff)
#define r193 (unsigned char)((CVD2_CHROMA_DTO_PAL_M   >>16)&0x000000ff)
#define r1a3 (unsigned char)((CVD2_CHROMA_DTO_PAL_M   >> 8)&0x000000ff)
#define r1b3 (unsigned char)((CVD2_CHROMA_DTO_PAL_M   >> 0)&0x000000ff)
#define r1c3 (unsigned char)(( CVD2_HSYNC_DTO_PAL_M   >>24)&0x000000ff)
#define r1d3 (unsigned char)(( CVD2_HSYNC_DTO_PAL_M   >>16)&0x000000ff)
#define r1e3 (unsigned char)(( CVD2_HSYNC_DTO_PAL_M   >> 8)&0x000000ff)
#define r1f3 (unsigned char)(( CVD2_HSYNC_DTO_PAL_M   >> 0)&0x000000ff)

#define r184 (unsigned char)((CVD2_CHROMA_DTO_PAL_60  >>24)&0x000000ff)
#define r194 (unsigned char)((CVD2_CHROMA_DTO_PAL_60  >>16)&0x000000ff)
#define r1a4 (unsigned char)((CVD2_CHROMA_DTO_PAL_60  >> 8)&0x000000ff)
#define r1b4 (unsigned char)((CVD2_CHROMA_DTO_PAL_60  >> 0)&0x000000ff)
#define r1c4 (unsigned char)(( CVD2_HSYNC_DTO_PAL_60  >>24)&0x000000ff)
#define r1d4 (unsigned char)(( CVD2_HSYNC_DTO_PAL_60  >>16)&0x000000ff)
#define r1e4 (unsigned char)(( CVD2_HSYNC_DTO_PAL_60  >> 8)&0x000000ff)
#define r1f4 (unsigned char)(( CVD2_HSYNC_DTO_PAL_60  >> 0)&0x000000ff)

#define r185 (unsigned char)((CVD2_CHROMA_DTO_PAL_CN  >>24)&0x000000ff)
#define r195 (unsigned char)((CVD2_CHROMA_DTO_PAL_CN  >>16)&0x000000ff)
#define r1a5 (unsigned char)((CVD2_CHROMA_DTO_PAL_CN  >> 8)&0x000000ff)
#define r1b5 (unsigned char)((CVD2_CHROMA_DTO_PAL_CN  >> 0)&0x000000ff)
#define r1c5 (unsigned char)(( CVD2_HSYNC_DTO_PAL_CN  >>24)&0x000000ff)
#define r1d5 (unsigned char)(( CVD2_HSYNC_DTO_PAL_CN  >>16)&0x000000ff)
#define r1e5 (unsigned char)(( CVD2_HSYNC_DTO_PAL_CN  >> 8)&0x000000ff)
#define r1f5 (unsigned char)(( CVD2_HSYNC_DTO_PAL_CN  >> 0)&0x000000ff)

#define r186 (unsigned char)((CVD2_CHROMA_DTO_SECAM   >>24)&0x000000ff)
#define r196 (unsigned char)((CVD2_CHROMA_DTO_SECAM   >>16)&0x000000ff)
#define r1a6 (unsigned char)((CVD2_CHROMA_DTO_SECAM   >> 8)&0x000000ff)
#define r1b6 (unsigned char)((CVD2_CHROMA_DTO_SECAM   >> 0)&0x000000ff)
#define r1c6 (unsigned char)(( CVD2_HSYNC_DTO_SECAM   >>24)&0x000000ff)
#define r1d6 (unsigned char)(( CVD2_HSYNC_DTO_SECAM   >>16)&0x000000ff)
#define r1e6 (unsigned char)(( CVD2_HSYNC_DTO_SECAM   >> 8)&0x000000ff)
#define r1f6 (unsigned char)(( CVD2_HSYNC_DTO_SECAM   >> 0)&0x000000ff)

// 00~3f
const unsigned char cvd_part1_table[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][CVD_PART1_REG_NUM] =
{
	{
		0x00, 0x08, 0x43, 0x10, 0xdd, 0x32, 0x80, 0x4e, 0x7b, 0x1c, 0x78, 0x00, 0x90, 0x00, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r180, r190, r1a0, r1b0, r1c0, r1d0, r1e0, r1f0,
		0x3e, 0x3e, 0x00, 0x80, 0xf3, 0x3e, 0x6d, 0x5a, 0x07, 0x29, 0xd6, 0x4e, 0x32, 0x46, 0x82, 0x50,
		0x22, 0x61, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x00, 0x01, 0x43, 0x82, 0xdd, 0x32, 0x80, 0x40, 0x7e, 0x20, 0x80, 0x00, 0x8a, 0x00, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r181, r191, r1a1, r1b1, r1c1, r1d1, r1e1, r1f1,
		0x3e, 0x3e, 0x00, 0x80, 0xf3, 0x3e, 0x6d, 0x5a, 0x07, 0x29, 0xd6, 0x4e, 0x32, 0x46, 0x7a, 0x50,
		0x22, 0x61, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x32, 0x04, 0x43, 0x12, 0xdd, 0x32, 0x80, 0x03, 0x7d, 0x20, 0x78, 0x00, 0x90, 0x00, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r182, r192, r1a2, r1b2, r1c2, r1d2, r1e2, r1f2,
		0x3e, 0x3e, 0x00, 0x80, 0xe7, 0x42, 0x6d, 0x5a, 0x1d, 0xb9, 0xd6, 0x4e, 0x32, 0x46, 0x8c, 0x50,
		0x2a, 0xc0, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x8a, 0x2e, 0x00, 0x0d, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x04, 0x01, 0x43, 0x12, 0xdd, 0x32, 0x80, 0x00, 0x7d, 0x20, 0x80, 0x00, 0x8a, 0x00, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r183, r193, r1a3, r1b3, r1c3, r1d3, r1e3, r1f3,
		0x3e, 0x3e, 0x00, 0x80, 0xf3, 0x3e, 0x6d, 0x5a, 0x07, 0x29, 0xd6, 0x4e, 0x32, 0x46, 0x82, 0x50,
		0x22, 0x61, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x04, 0x00, 0x43, 0x02, 0xdd, 0x32, 0x80, 0x00, 0x80, 0x20, 0x80, 0x00, 0x67, 0x01, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r184, r194, r1a4, r1b4, r1c4, r1d4, r1e4, r1f4,
		0x3e, 0x3e, 0x00, 0x80, 0xf3, 0x3e, 0x6d, 0x5a, 0x07, 0x29, 0xd6, 0x4e, 0x32, 0x46, 0x84, 0x50,
		0x2a, 0x61, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_PAL_60,
	{
		0x36, 0x01, 0x43, 0x12, 0xdd, 0x32, 0x80, 0x00, 0x7d, 0x31, 0x80, 0x00, 0x8a, 0x00, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r185, r195, r1a5, r1b5, r1c5, r1d5, r1e5, r1f5,
		0x3e, 0x3e, 0x00, 0x80, 0xf3, 0x3e, 0x6d, 0x5a, 0x07, 0x29, 0xd6, 0x4e, 0x32, 0x46, 0x8a, 0x50,
		0x2d, 0xc1, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x38, 0x00, 0x43, 0x00, 0xdc, 0x32, 0x80, 0x00, 0x80, 0x20, 0x80, 0x00, 0xc8, 0x00, 0x06, 0x00,
		0x37, 0x09, 0x10, 0xb4, 0x80, 0x20, 0xf6, 0x0d, r186, r196, r1a6, r1b6, r1c6, r1d6, r1e6, r1f6,
		0x3e, 0x3e, 0x00, 0x80, 0xf3, 0x3e, 0x6d, 0x5a, 0x07, 0x29, 0xd6, 0x4e, 0x3c, 0x6e, 0x76, 0x58,
		0x29, 0xbf, 0x70, 0x0e, 0x6c, 0x10, 0x00, 0x23, 0x01, 0x8a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01
	}, // TVIN_SIG_FMT_CVBS_SECAM,
};

#define r_81 0x00
#define r_89 0x00
#define r_8c 0x00
#define r_97 0x00
#define r_98 0x00
#define r_99 0x00
#define r_9a 0x00
#define r_9b 0x00
#define r_9c 0x00
#define r_9d 0x00
#define r_9e 0x00
#define r_9f 0x00
#define r_ad 0x00
#define r_b9 0x00
#define r_bf 0x00
#define r_c1 (unsigned char)(CVD2_DCRESTORE_ACCUM)
#define r_cf 0x00
#define r_dd 0x00
#define r_df 0x00
#define r_ef 0x00
#define r_f5 0x00
#define r_f6 0x00
#define r_f7 0x00
#define r_f8 0x00
#define r_ff 0x00
// 70~ff
const unsigned char cvd_part2_table[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][CVD_PART2_REG_NUM] =
{
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x04, r_81, 0x42, 0x6f, 0x03, 0x00, 0x00, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x01, 0x08, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x16, 0x0f, 0xc1, r_ad, 0xcf, 0x0f,
		0x30, 0x2d, 0x04, 0x0b, 0x23, 0xa2, 0x02, 0x00, 0x00, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x14, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x7d, 0xf0, 0x01, 0x50, 0x60, 0x90, 0xe3, 0x0c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x50, r_dd, 0x08, r_df,
		0x00, 0x00, 0x00, 0x00, 0x6e, 0x50, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x40, 0x32, 0x46, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x00, 0x32, 0x50, 0x1c, 0x00, r_ff
	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x04, r_81, 0x42, 0x6f, 0x03, 0x00, 0x00, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x01, 0x00, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x16, 0x0f, 0xc1, r_ad, 0xcf, 0x8c,
		0xe0, 0x2d, 0x8,  0x03, 0x24, 0xa2, 0x02, 0x00, 0x00, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x17, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x00, 0x00, 0x01, 0x50, 0x62, 0x90, 0xe3, 0x0c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x50, r_dd, 0x08, r_df,
		0x00, 0x00, 0x00, 0x00, 0x6e, 0x40, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x40, 0x32, 0x46, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x00, 0x32, 0x50, 0x1c, 0x00, r_ff
	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x04, 0x7f, 0x42, 0x6f, 0x03, 0x00, 0x04, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x1f, 0x00, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x16, 0x0f, 0xc1, r_ad, 0xcf, 0x86,
		0xfa, 0x2f, 0x0c, 0x03, 0x23, 0xa2, 0x02, 0x00, 0x08, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x14, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x00, 0xf0, 0x01, 0x50, 0x62, 0x90, 0xe3, 0x2c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x40, r_dd, 0x08, r_df,
		0x00, 0x01, 0xc2, 0x88, 0x6e, 0x50, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x1f, 0x32, 0x46, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x80, 0x32, 0x50, 0x1c, 0x00, r_ff
	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x04, r_81, 0x42, 0x6f, 0x03, 0x00, 0x00, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x01, 0x00, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x16, 0x0f, 0xc1, r_ad, 0xcf, 0x8c,
		0x3a, 0xf3, 0x0c, 0x03, 0x23, 0xa2, 0x02, 0x00, 0x00, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x14, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x00, 0x00, 0x01, 0x50, 0x62, 0x90, 0xe3, 0x2c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x50, r_dd, 0x08, r_df,
		0x00, 0x00, 0x00, 0x00, 0x6e, 0x50, 0x8c, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x1f, 0x32, 0x46, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x00, 0x32, 0x50, 0x1c, 0x00, r_ff
	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x04, r_81, 0x42, 0x6f, 0x03, 0x00, 0x00, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x01, 0x00, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x16, 0x0f, 0xc1, r_ad, 0xcf, 0x8c,
		0xe0, 0x2f, 0x0c, 0x0b, 0x24, 0xa2, 0x02, 0x00, 0x00, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x14, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x00, 0x00, 0x01, 0x50, 0x62, 0x90, 0xe3, 0x0c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x50, r_dd, 0x08, r_df,
		0x00, 0x00, 0x00, 0x00, 0x6e, 0x40, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x40, 0x32, 0x46, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x00, 0x32, 0x50, 0x05, 0x00, r_ff
	}, // TVIN_SIG_FMT_CVBS_PAL_60,
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x04, r_81, 0x42, 0x6f, 0x03, 0x00, 0x03, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x01, 0x00, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x16, 0x0f, 0xc1, r_ad, 0xcf, 0x8c,
		0xe0, 0x2f, 0x0c, 0x03, 0x24, 0xa2, 0x02, 0x00, 0x00, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x14, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x00, 0x00, 0x01, 0x50, 0x62, 0x90, 0xe3, 0x2c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x50, r_dd, 0x08, r_df,
		0x00, 0x00, 0x00, 0x00, 0x6e, 0x50, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x1f, 0x32, 0x46, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x00, 0x32, 0x50, 0x1c, 0xdc, r_ff
	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x84, r_81, 0x42, 0x6f, 0x03, 0x00, 0x00, 0x00, 0x00, r_89, 0x0a, 0x11, r_8c, 0x0a, 0x00, 0xe2,
		0x00, 0x00, 0x01, 0x00, 0x08, 0x00, 0x00, r_97, r_98, r_99, r_9a, r_9b, r_9c, r_9d, r_9e, r_9f,
		0xf2, 0x0b, 0x00, 0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x5f, 0x0f, 0x00, r_ad, 0xcf, 0x8c,
		0xe0, 0x2f, 0x0c, 0x03, 0x24, 0x22, 0x02, 0x00, 0x00, r_b9, 0x24, 0x5f, 0x00, 0x25, 0x55, r_bf,
		0x14, r_c1, 0x40, 0xc0, 0xfe, 0x90, 0x00, 0x00, 0x01, 0x50, 0x62, 0x90, 0xe3, 0x0c, 0x23, r_cf,
		0xc0, 0x08, 0x10, 0x10, 0x0a, 0x00, 0x0d, 0x00, 0x00, 0x05, 0x00, 0x05, 0x50, r_dd, 0x1f, r_df,
		0x00, 0x00, 0x00, 0x00, 0x6e, 0x40, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, r_ef,
		0x20, 0x40, 0x3c, 0x6e, 0xe4, r_f5, r_f6, r_f7, r_f8, 0x01, 0x00, 0x50, 0x6e, 0x05, 0xdc, r_ff
	}, // TVIN_SIG_FMT_CVBS_SECAM,
};

// 0x87, 0x93, 0x94, 0x95, 0x96, 0xe6, 0xfa
const unsigned int cvd_part3_table[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][CVD_PART3_REG_NUM] =
{
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000000
	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000000
	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000080
	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000080
	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000080
	}, // TVIN_SIG_FMT_CVBS_PAL_60,
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000080
	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x00000000, 0x98000000, 0x0000FF08, 0x00000000, 0x8b000000, 0x0000008c, 0x00000080
	}, // TVIN_SIG_FMT_CVBS_SECAM,

};


const unsigned int cvbs_acd_table[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][ACD_REG_NUM+1] =
{
	{
		0x10101002,0x0,       0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG0:0-7
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0x1010403c,0x44060606,0x08080044,0x00080808,0xc006844b,0x40200808,0x44440044,0x00008c80,//REG1
		0xf0008888,0xa0461006,0x70ff0404,0x0400208c,0x48484848,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x08000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x2,       0xe7f14e8e,//REG2:0-7
		0x00000008,0x20070000,0x0036e946,0x00001001,0x10e0474f,0x00930363,0x00130103,0x00000000,//REG2:8-F
		0x00000000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004cfb0,0x00000000,0x030000f0,0x0000000a,0x0000164e,0x0003d55e,0x000000f0,//REG3
		0x00000001,0x00000400,0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG4
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x50502070,0x401020,  0xc9801c0c,0x21f00ff, 0x8080801c,//REG5
		0x81f11111,0x81f85852,0x00680068,0x0487101c,0x00000003,0x00000000,0x00012002,0x00028040,//REG5
		0x00000000,0x08000000,0x7f1ff000,0x00000000,0x10101040,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x80000000,0x00000000,0x00000000,0xa00833da,//REG6
		0xba5b0391,0x000ae232,0x00000000,0xf0080610,0x3000180a,0x9c10,    0x00000182,0x00000000,//REG7
		0x81000002,0x83020010,0x000121ff,0x000c0340,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x75777577,0x00000000,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x002468b5,0x002fa63a,0x0143a740,//REG8
		0x00032864,0x00001b10,0x0371d249,0x0003ebde,0x00032864,0x00001b10,0x0371d249,0x0003ebde,//REG9
		0X00032864,0x00001b10,0x0371d249,0x0003ebde,0x00032864,0x00001b10,0x0371d249,0x0003ebde,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x75777577,0x00000000,0x00192718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x00247e04,0x002fa52a,0x0143a2ef,//REGC
		0x000327bf,0x00001b03,0x0371b470,0x0003f28b,0x000327bf,0x00001b03,0x0371b470,0x0003f28b,//REGD
		0x000327bf,0x00001b03,0x0371b470,0x0003f28b,0x000327bf,0x00001b03,0x0371b470,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x0f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF:0-7
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff//REGF:8-F

	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x10101002,0x10101010,0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG0:0-7
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0x1010603c,0x44060606,0x08080044,0x00080808,0x0c06844b,0x40200808,0x44440044,0x00008c80,//REG1:0-7
		0xf0008888,0xa0461006,0x70ff0404,0x0000208c,0x48484848,0x00004444,0x00000000,0x00000000,//REG1:8-F
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000002,0xe7f14e8e,//REG2
		0x00000008,0x20070000,0x0036e946,0x00001001,0x10e0474f,0x00930363,0x00120102,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d068,0x00000000,0x030000f0,0x0000000a,0x000013f0,0x0003d300,0x000000f0,//REG3
		0x00000001,0x00000400,0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG4
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x40403070,0x04281020,0x00000000,0x021000ff,0x80688030,//REG5
		0x81f11111,0x81f85852,0x00680068,0x0487101c,0x00000003,0x00000000,0x00012002,0x00028040,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x10101040,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x80000000,0x00000000,0x00000000,0xc00833da,//REG6
		0xba5b0391,0x000ae232,0x00000000,0xf0080610,0x60001808,0x00009410,0x00000003,0x00000000,//REG7
		0x81018014,0x03020010,0x000121ff,0x000c0340,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x75757577,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x01c12807,0x00000000,0x00000000,//REG8
		0x000ff511,0x00000000,0x0012198b,0x037d7036,0x000ff511,0x00000000,0x0012198b,0x037d7036,//REG9
		0x000ff511,0x00000000,0x0012198b,0x037d7036,0x000ff511,0x00000000,0x0012198b,0x037d7036,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x75757577,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x01c08fed,0x00000000,0x00000000,//REGC
		0x000feeef,0x00000000,0x001213ab,0x037b5071,0x000feeef,0x00000000,0x001213ab,0x037b5071,//REGD
		0x000feeef,0x00000000,0x001213ab,0x037b5071,0x000feeef,0x00000000,0x001213ab,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x22222202,0x22222222,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0x1010403c,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x70ff0404,0x400208c, 0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x08000000,0x02020000,0x0209c832,0x00000000,0xfcf44396,0x2,       0xe7f14e8e,//REG2
		0x00000008,0x20800000,0x00275a60,0x00001001,0x10e0474f,0x00890359,0x00170137,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d206,0x00000000,0x030000f0,0x0000000a,0x0000523e,0x0004114e,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x18188080,0x601838,  0xc9804c18,0x020f00ff,0x80808020,//REG5
		0x88711111,0x81f24742,0x80380038,0x10000,   0x00000003,0x00000000,0x00000000,0x00300000,//REG5
		0x00000000,0x08000000,0x7f1ff000,0x00000000,0x80c0c080,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0xa00833da,//REG6
		0xba5b0391,0x000ae232,0x00000000,0xf0080610,0x08104008,0x2c10,    0x00000003,0x00000000,//REG7
		0x88001002,0x3020010, 0x000281ff,0x000803c0,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x74777477,0x00000000,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x18004,   0x00200000,0x00000000,0x00000000,0x00eb2aac,0x00000000,0x00000000,//REG8
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x3f000100,0x8f000004,0x3f000100,0x0f000004,0x00000002,0x00000000,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x74777477,0x00000000,0x00192718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018004,0x00200000,0x00000000,0x00000000,0x010d753b,0x00000000,0x00000000,//REGC
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x05520b96,//REGD
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF
	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00002108,0x00000000,0x0026e905,0x00001001,0x10e0474f,0x00700340,0x00100100,0x000a0000,//REG2
		0x00080000,0x00000000,0x000a0000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d019,0x00000000,0x030000f0,0x0000000a,0x0000442d,0x0004033d,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205040,0x0050c0c0,0x00000000,0x020f00ff,0x80808020,//REG5
		0x81f11111,0x81f24742,0x80200020,0x03000000,0x00000003,0x00000000,0x00000000,0x00300000,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x40404040,0x40404040,0x00000000,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG 6
		0xb3640378,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x00400040,0x00080040,0x000281ff,0x000803c0,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x75767576,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x027d7b59,0x00000000,0x00000000,//REG 8
		0x001540c8,0x00000000,0x00000000,0x03ca7af4,0x001540c8,0x00000000,0x00000000,0x03ca7af4,//REG9
		0x001540c8,0x00000000,0x00000000,0x03ca7af4,0x001540c8,0x00000000,0x00000000,0x03ca7af4,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x75767576,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x0282ce1c,0x00000000,0x00000000,//REGC
		0x00153fb2,0x00000000,0x00000000,0x03ca7c7c,0x00153be2,0x00000000,0x00000000,0x03ca7c7c,//REGD
		0x00153be2,0x00000000,0x00000000,0x03ca7c7c,0x00153be2,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x08000000,0x02020000,0x0209c832,0x00000000,0xfcf44396,0x00000102,0xe7f14e8e,//REG2
		0x00000008,0x20800000,0x00275a60,0x00001001,0x10e0474f,0x00890359,0x00170137,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d206,0x00000000,0x030000f0,0x0000000a,0x0000523e,0x0004114e,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205070,0x0050a0a0,0x00000000,0x020f00ff,0x80808020,//REG5
		0x80711111,0x81f24742,0x80380038,0x03061010,0x00000003,0x00000000,0x00000000,0x00300000,//REG5
		0x00000000,0x08000000,0x7f1ff000,0x00000000,0x80c0c080,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0xa00833da,//REG6
		0xba5b0391,0x000ae232,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x88001002,0x83024016,0x000281ff,0x000803c0,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x74777477,0x00000000,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018004,0x00200000,0x00000000,0x00000000,0x00eb2aac,0x00000000,0x00000000,//REG8
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x3f000100,0x8f000004,0x3f000100,0x0f000004,0x00000002,0x00000000,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x74777477,0x00000000,0x00192718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018004,0x00200000,0x00000000,0x00000000,0x010d753b,0x00000000,0x00000000,//REGC
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x05520b96,//REGD
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF
	}, // TVIN_SIG_FMT_CVBS_PAL_60,the same to TVIN_SIG_FMT_CVBS_PAL_I
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00002108,0x00070000,0x002717d9,0x00001001,0x10e0474f,0x00700340,0x00100100,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d1fb,0x00000000,0x030000f0,0x0000000a,0x00005fef,0x00041eff,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205040,0x0050c0c0,0x00000000,0x020f00ff,0x80808020,//REG5
		0x81f11111,0x81f24742,0x80200020,0x03000000,0x00000003,0x00000000,0x00000000,0x00000000,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x40404040,0x40404040,0x00000000,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3640378,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x00400040,0x00080040,0x00fff000,0x00040000,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00c2befd,0x00000000,0x00000000,//REG8
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00b57c68,0x00000000,0x00000000,//REGC
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,//REGD
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x00000003,//REG D
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REG E
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG 1
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00000108,0x00070000,0x002717d9,0x00001001,0x10e0474f,0x00700340,0x00170137,0x00000000,//REG 2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d1fb,0x00000000,0x030000f0,0x0000000a,0x00005fef,0x00041eff,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205040,0x0050c0c0,0x00000000,0x020f00ff,0x00808020,//REG5
		0x81f11111,0x81f24742,0x80200020,0x03000000,0x00000003,0x00000000,0x00000000,0x00000000,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x40404040,0x40404040,0x00000000,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3640378,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x00400040,0x00080040,0x00fff000,0x00040000,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00c2befd,0x00000000,0x00000000,//REG8
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00b57c68,0x00000000,0x00000000,//REGC
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,//REGD
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x00000003,//REG D
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REG E
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF

	}, // TVIN_SIG_FMT_CVBS_SECAM,
};


const unsigned int rf_acd_table[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][ACD_REG_NUM+1] =
{
	{
		0x10101002,0x0,       0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG0:0-7
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0x1010403c,0x44060606,0x08080044,0x00080808,0xc006844b,0x40200808,0x44440044,0x00008c80,//REG1
		0xf0008888,0xa0461006,0x70ff0404,0x0400208c,0x48484848,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x08000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x2,       0xe7f14e8e,//REG2:0-7
		0x00000008,0x20070000,0x0036e946,0x00001001,0x10e0474f,0x00930363,0x00130103,0x00000000,//REG2:8-F
		0x00000000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004cfb0,0x00000000,0x030000f0,0x0000000a,0x0000164e,0x0003d55e,0x000000f0,//REG3
		0x00000001,0x00000400,0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG4
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x50502070,0x401020,  0xc9801c0c,0x21f00ff, 0x8080801c,//REG5
		0x81f11111,0x81f85852,0x00680068,0x0487101c,0x00000003,0x00000000,0x00012002,0x00028040,//REG5
		0x00000000,0x08000000,0x7f1ff000,0x00000000,0x10101040,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x80000000,0x00000000,0x00000000,0xa00833da,//REG6
		0xba5b0391,0x000ae232,0x00000000,0xf0080610,0x3000180a,0x9c10,    0x00000182,0x00000000,//REG7
		0x81000002,0x83020010,0x000121ff,0x000c0340,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x75777577,0x00000000,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x002468b5,0x002fa63a,0x0143a740,//REG8
		0x00032864,0x00001b10,0x0371d249,0x0003ebde,0x00032864,0x00001b10,0x0371d249,0x0003ebde,//REG9
		0X00032864,0x00001b10,0x0371d249,0x0003ebde,0x00032864,0x00001b10,0x0371d249,0x0003ebde,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x75777577,0x00000000,0x00192718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x00247e04,0x002fa52a,0x0143a2ef,//REGC
		0x000327bf,0x00001b03,0x0371b470,0x0003f28b,0x000327bf,0x00001b03,0x0371b470,0x0003f28b,//REGD
		0x000327bf,0x00001b03,0x0371b470,0x0003f28b,0x000327bf,0x00001b03,0x0371b470,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x0f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF:0-7
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff//REGF:8-F
	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x10101002,0x10101010,0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG0:0-7
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0x1010603c,0x44060606,0x08080044,0x00080808,0x0c06844b,0x40200808,0x44440044,0x00008c80,//REG1:0-7
		0xf0008888,0xa0461006,0x70ff0404,0x0000208c,0x48484848,0x00004444,0x00000000,0x00000000,//REG1:8-F
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00000008,0x20070000,0x0036e946,0x00001001,0x10e0474f,0x00930363,0x00120102,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d068,0x00000000,0x030000f0,0x0000000a,0x000013f0,0x0003d300,0x000000f0,//REG3
		0x00000001,0x00000400,0x7f00e110,0x08881e18,0xb36d1858,0x00007612,0x00000000,0x77444444,//REG4
		0x20e000fe,0x00000101,0x0c000100,0x80010909,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x40403070,0x04281020,0x00000000,0x021000ff,0x80688030,//REG5
		0x81f11111,0x81f85852,0x00680068,0x0487101c,0x00000003,0x00000000,0x00012002,0x00028040,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x10101040,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x80000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3630387,0x000bdf37,0x00000000,0xf0080610,0x60001808,0x00009410,0x00000003,0x00000000,//REG7
		0x81018014,0x83020010,0x000121ff,0x000c0340,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x75757577,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x01c12807,0x00000000,0x00000000,//REG8
		0x000ff511,0x00000000,0x0012198b,0x037d7036,0x000ff511,0x00000000,0x0012198b,0x037d7036,//REG9
		0x000ff511,0x00000000,0x0012198b,0x037d7036,0x000ff511,0x00000000,0x0012198b,0x037d7036,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x75757577,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x00018018,0x00040010,0x00000000,0x00000000,0x01c08fed,0x00000000,0x00000000,//REGC
		0x000feeef,0x00000000,0x001213ab,0x037b5071,0x000feeef,0x00000000,0x001213ab,0x037b5071,//REGD
		0x000feeef,0x00000000,0x001213ab,0x037b5071,0x000feeef,0x00000000,0x001213ab,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF

	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x22222202,0x22222222,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0x1010403c,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x70ff0404,0x208c,    0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x08000000,0x02020000,0x0209c832,0x00000000,0xfcf44396,0x2,       0xe7f14e8e,//REG2
		0x00000008,0x20800000,0x00275a60,0x00001001,0x10e0474f,0x00890359,0x00170137,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d206,0x00000000,0x030000f0,0x0000000a,0x0000523e,0x0004114e,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x28284080,0x602020,  0xc9804c08,0x020f00ff,0x80808020,//REG5
		0x88711111,0x81f24742,0x80380038,0x10000,   0x00000003,0x00000000,0x00000000,0x00300000,//REG5
		0x00000000,0x08000000,0x7f1ff000,0x00000000,0x80c0c080,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0xa00833da,//REG6
		0xba5b0391,0x000ae232,0x00000000,0xf0080610,0x08104008,0x2c10,    0x00000003,0x00000000,//REG7
		0x88001002,0x3020010, 0x000281ff,0x000803c0,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x74777477,0x00000000,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x18004,   0x00200000,0x00000000,0x00000000,0x00eb2aac,0x00000000,0x00000000,//REG8
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x3f000100,0x8f000004,0x3f000100,0x0f000004,0x00000002,0x00000000,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x74777477,0x00000000,0x00192718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018004,0x00200000,0x00000000,0x00000000,0x010d753b,0x00000000,0x00000000,//REGC
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x05520b96,//REGD
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF

	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00000108,0x00000000,0x0026e905,0x00001001,0x10e0474f,0x00880358,0x00130103,0x000a0000,//REG2
		0x00080000,0x00000000,0x000a0000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d019,0x00000000,0x030000f0,0x0000000a,0x0000442d,0x0004033d,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205040,0x0050c0c0,0x00000000,0x020f00ff,0x00808020,//REG5
		0x81f11111,0x81f24742,0x80200020,0x03000000,0x00000003,0x00000000,0x00000000,0x80300000,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x40404040,0x40404040,0x00000000,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3640378,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x00400040,0x00080040,0x000281ff,0x000803c0,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x75767576,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x027d7b59,0x00000000,0x00000000,//REG8
		0x001540c8,0x00000000,0x00000000,0x03ca7af4,0x001540c8,0x00000000,0x00000000,0x03ca7af4,//REG9
		0x001540c8,0x00000000,0x00000000,0x03ca7af4,0x001540c8,0x00000000,0x00000000,0x03ca7af4,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x75767576,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x0282ce1c,0x00000000,0x00000000,//REGC
		0x00153fb2,0x00000000,0x00000000,0x03ca7c7c,0x00153be2,0x00000000,0x00000000,0x03ca7c7c,//REGD
		0x00153be2,0x00000000,0x00000000,0x03ca7c7c,0x00153be2,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF

	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x08000000,0x02020000,0x0209c832,0x00000000,0xfcf44396,0x00000102,0xe7f14e8e,//REG2
		0x00000008,0x20800000,0x00275a60,0x00001001,0x10e0474f,0x00890359,0x00170137,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d206,0x00000000,0x030000f0,0x0000000a,0x0000523e,0x0004114e,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205070,0x0050a0a0,0x00000000,0x020f00ff,0x80808020,//REG5
		0x80711111,0x81f24742,0x80380038,0x03061010,0x00000003,0x00000000,0x00000000,0x00300000,//REG5
		0x00000000,0x08000000,0x7f1ff000,0x00000000,0x80c0c080,0x40404040,0x80000f5c,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3630387,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x88001002,0x83024016,0x000281ff,0x000803c0,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0x74777477,0x00000000,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018004,0x00200000,0x00000000,0x00000000,0x00eb2aac,0x00000000,0x00000000,//REG8
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x001652f7,0x00000000,0x00000000,0x04974980,0x001652f7,0x00000000,0x00000000,0x04974980,//REG9
		0x3f000100,0x8f000004,0x3f000100,0x0f000004,0x00000002,0x00000000,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGA
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0x74777477,0x00000000,0x00192718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018004,0x00200000,0x00000000,0x00000000,0x010d753b,0x00000000,0x00000000,//REGC
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x05520b96,//REGD
		0x0018c65f,0x00000000,0x00000000,0x05520b96,0x0018c65f,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGE
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF
		0x3f000100,0x8f000004,0x3f000100,0x8f000004,0x00000002,0x90000fff,0x00000002,0x90000fff,//REGF

	}, // TVIN_SIG_FMT_CVBS_PAL_60,the same to TVIN_SIG_FMT_CVBS_PAL_I
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00002108,0x00070000,0x002717d9,0x00001001,0x10e0474f,0x00700340,0x00100100,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d1fb,0x00000000,0x030000f0,0x0000000a,0x00005fef,0x00041eff,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205040,0x0050c0c0,0x00000000,0x020f00ff,0x80808020,//REG5
		0x81f11111,0x81f24742,0x80200020,0x03000000,0x00000003,0x00000000,0x00000000,0x00000000,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x40404040,0x40404040,0x00000000,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3640378,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x00400040,0x00080040,0x00fff000,0x00040000,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00c2befd,0x00000000,0x00000000,//REG8
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00b57c68,0x00000000,0x00000000,//REGC
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,//REGD
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF

	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x01010101,0x01010101,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG0:0-7
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG0:8-F
		0xc0c0600f,0x44441010,0x10100444,0x00101010,0x40c09008,0x44808080,0x44440844,0x00008c80,//REG1
		0x01008888,0x30100c01,0x40ff0400,0x0427208c,0x88888888,0x00004444,0x00000000,0x00000000,//REG1
		0x00000000,0x10000000,0x02020000,0x0209c832,0x00000000,0xeafb4e8e,0x00000102,0xe7f14e8e,//REG2
		0x00000108,0x00070000,0x002717d9,0x00001001,0x10e0474f,0x00700340,0x00170137,0x00000000,//REG2
		0x00070000,0x00000000,0x00000000,0x00000050,0x00000000,0x000003ff,0x00000000,0x00000000,//REG3
		0x00000000,0x0004d1fb,0x00000000,0x030000f0,0x0000000a,0x00005fef,0x00041eff,0x000000f0,//REG3
		0x00000001,0x00000400,0x00004110,0x08881e28,0xe4962858,0x00008e19,0x00000000,0x66666442,//REG4
		0x20e00044,0x00000101,0x00000000,0x80010101,0x00000000,0x00000000,0x00000000,0x00000000,//REG4
		0x00000000,0x00000000,0x00000000,0x08205040,0x0050c0c0,0x00000000,0x020f00ff,0x80808020,//REG5
		0x81f11111,0x81f24742,0x80200020,0x03000000,0x00000003,0x00000000,0x00000000,0x00000000,//REG5
		0x00000000,0x10000000,0x7f1ff000,0x00000000,0x40404040,0x40404040,0x00000000,0xff000000,//REG6
		0x00000000,0x00000000,0x00ffffff,0x00000fff,0x00000000,0x00000000,0x00000000,0x2008f433,//REG6
		0xb3640378,0x000bdf37,0x00000000,0xf0080610,0x08104008,0x00002410,0x00000003,0x00000000,//REG7
		0x00400040,0x00080040,0x00fff000,0x00040000,0x40305c1c,0x00d63650,0x00c184af,0x00c1837f,//REG7
		0x00c18329,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REG8
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00c2befd,0x00000000,0x00000000,//REG8
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x00047fcc,0x00000000,0x00000000,0x04591a41,0x00047fcc,0x00000000,0x00000000,0x04591a41,//REG9
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x00000000,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGA
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGB
		0x00c1837e,0x01000100,0x43062222,0xf3f6f4f8,0x00000002,0x00000718,0x9968edd6,0x3553fab0,//REGC
		0x026f2865,0x80018018,0x00800000,0x00000000,0x00000000,0x00b57c68,0x00000000,0x00000000,//REGC
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,//REGD
		0x00042c0d,0x00000000,0x00000000,0x03dc2e7a,0x00042c0d,0x00000000,0x00000000,0x00000003,//REGD
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGE
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
		0x3f000100,0x0fff0000,0x3f000100,0x0fff0000,0x00000000,0x90000fff,0x00000000,0x90000fff,//REGF
	}, // TVIN_SIG_FMT_CVBS_SECAM,
};


//0x00-0x03
const unsigned char cvd_yc_reg_0x00_0x03[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][4] =
{
	{
		0x01, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x01, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x33, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x00, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x00, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_PAL_60,
	{
		0x00, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x00, 0x08, 0x42, 0x22,
	}, // TVIN_SIG_FMT_CVBS_SECAM,
};

//0x18-0x1f
const unsigned char cvd_yc_reg_0x18_0x1f[TVIN_SIG_FMT_CVBS_SECAM-TVIN_SIG_FMT_CVBS_NTSC_M+1][8] =
{
	{
		0x21, 0xf0, 0x7c, 0x1f, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_NTSC_M,
	{
		0x21, 0xf0, 0x7c, 0x1f, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_NTSC_443,
	{
		0x2f, 0x4a, 0xbc, 0x24, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_PAL_I,
	{
		0x21, 0xe6, 0xef, 0xa4, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_PAL_M,
	{
		0x21, 0xf6, 0x94, 0x46, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_PAL_60,
	{
		0x21, 0xf6, 0x94, 0x46, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_PAL_CN,
	{
		0x28, 0xa3, 0x3b, 0xb2, 0x24, 0x00, 0x00, 0x00,
	}, // TVIN_SIG_FMT_CVBS_SECAM,
};


EXPORT_SYMBOL(tvin_vga_fmt_tbl);
EXPORT_SYMBOL(tvin_comp_fmt_tbl);
EXPORT_SYMBOL(tvin_hdmi_fmt_tbl);
EXPORT_SYMBOL(tvin_cvbs_fmt_tbl);
EXPORT_SYMBOL(tvin_bt601_fmt_tbl);

EXPORT_SYMBOL(adc_vga_table);
EXPORT_SYMBOL(adc_component_table);
EXPORT_SYMBOL(adc_cvbs_table);
EXPORT_SYMBOL(cvd_part1_table);
EXPORT_SYMBOL(cvd_part2_table);
EXPORT_SYMBOL(cvd_part3_table);
EXPORT_SYMBOL(cvbs_acd_table);
EXPORT_SYMBOL(rf_acd_table);


EXPORT_SYMBOL(cvd_yc_reg_0x00_0x03);
EXPORT_SYMBOL(cvd_yc_reg_0x18_0x1f);


MODULE_LICENSE("GPL");

